Markers in EJ2 JavaScript Maps component

12 Feb 202624 minutes to read

Markers are visual indicators used to pinpoint specific locations on the Maps. They can display desired symbols to highlight points of interest or important geographic positions. Markers can be enabled by setting the visible property of the markerSettings to true.

Adding marker

The dataSource property of the markerSettings has a list of objects that contains the data for Markers. Using this property, any number of markers can be added to the shape layers. By default, it displays the markers based on the specified latitude and longitude in the given data source. Each data source object contains the following list of properties.

  • label - Text that displays some information about the marker in text format.
  • latitude - The latitude value that determines the vertical (Y) position of the marker.
  • longitude - The longitude value that determines the horizontal (X) position of the marker.

markerSettings is an Array property.

var map = new ej.maps.Maps({
   layers: [{
        shapeData: world_map,
        markerSettings: [
            { 
                visible: true,
                height: 20,
                width: 20,
                dataSource: [
                    { latitude: 49.95121990866204, longitude: 18.468749999999998 },
                    { latitude: 59.88893689676585, longitude: -109.3359375 },
                    { latitude: -6.64607562172573, longitude: -55.54687499999999 }
                ],
                animationDuration: 0,
            },
        ]
    }]
});
map.appendTo('#element');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Maps</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">

    <script src="world-map.js"></script>

    <script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>

    <div id="container" style="height: 500px; width: 700px">
        <div id="element"></div>
    </div>

    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Adding marker template

The Marker can be added as a template in the Maps component. The template property of the markerSettings is used to set the Marker as a template. HTML element or id of an element can be added as the template in Markers.

var map = new ej.maps.Maps({
    layers: [{
        shapeData: world_map,
        markerSettings: [
        {
            visible: true,
            template: '<div id="marker4" class="markerTemplate">Europe' +
                '</div>',
            dataSource: [
                { latitude: 49.95121990866204, longitude: 18.468749999999998 }
            ],
            animationDuration: 0,
        },
        {
            visible: true,
            template: '<div id="marker5" class="markerTemplate" style="width:50px">North America' +
                '</div>',
            dataSource: [
                { latitude: 59.88893689676585, longitude: -109.3359375 }
            ],
            animationDuration: 0
        },
        {
            visible: true,
            template: '<div id="marker6" class="markerTemplate" style="width:50px">South America' +
                '</div>',
            dataSource: [
                { latitude: -6.64607562172573, longitude: -55.54687499999999 }
            ],
            animationDuration: 0
        },
        ]
    }]
});
map.appendTo('#element');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Maps</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">

    <script src="world-map.js"></script>

    <script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>

    <div id="container" style="height: 500px; width: 700px">
        <div id="element"></div>
    </div>

    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Customization

The following properties are available in markerSettings to customize the Markers of the Maps component.

  • border - To customize the color, width and opacity of the border for the markers in Maps.
  • fill - To apply the color for markers in Maps.
  • dashArray - To define the pattern of dashes and gaps that is applied to the outline of the markers in Maps.
  • height - To customize the height of the markers in Maps.
  • width - To customize the width of the markers in Maps.
  • offset - To customize the position of the markers in Maps.
  • opacity - To customize the transparency of the markers in Maps.
  • animationDelay - To change the time delay in the transition for markers.
  • animationDuration - To change the time duration of animation for markers.
  • highlightSettings - To customize the highlight settings for the marker in Maps.
  • selectionSettings - To customize the selection settings for the marker in Maps.
var map = new ej.maps.Maps({
    layers: [{
        shapeData: world_map,
        markerSettings: [{
            visible: true,
            border: {
                color: 'green',
                width: 2
            },
            fill: 'red',
            dashArray: '1',
            height: 20,
            width: 20,
            opacity: 0.9,
            animationDelay: 100,
            animationDuration: 1000,
            shape: 'Balloon',
            dataSource: [
                { latitude: 37.0000, longitude: -120.0000, city: 'California' },
                { latitude: 40.7127, longitude: -74.0059, city: 'New York' },
                { latitude: 42, longitude: -93, city: 'Iowa' }
            ]
        }]
    }]
});
map.appendTo('#element');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Maps</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">

    <script src="world-map.js"></script>
    <script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>

    <div id="container" style="height: 500px; width: 700px">
        <div id="element"></div>
    </div>

    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Marker shapes

The Maps component supports the following marker shapes. To set the shape of the marker, the shape property in markerSettings is used.

  • Balloon
  • Circle
  • Cross
  • Diamond
  • Image
  • Rectangle
  • Star
  • Triangle
  • VerticalLine
  • HorizontalLine

Rendering Marker shape as image

To render a marker as an image in Maps, set the shape property of markerSettings as Image and specify the path of the image to imageUrl property. There is another way to render a marker as an image using the imageUrlValuePath property of the markerSettings. Bind the field name that contains the path of the image in the data source to the imageUrlValuePath property.

var map = new ej.maps.Maps({
    layers: [{
        shapeData: world_map,
        markerSettings: [{
            visible: true,
            shape: 'Image',
            imageUrl: 'https://ej2.syncfusion.com/javascript/demos/src/maps/images/ballon.png',
            height: 20,
            width: 20,
            dataSource: [
                { latitude: 37.0000, longitude: -120.0000, city: 'California' },
                { latitude: 40.7127, longitude: -74.0059, city: 'New York' },
                { latitude: 42, longitude: -93, city: 'Iowa' }
            ]
        }]
    }]
});
map.appendTo('#element');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Maps</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">

    <script src="world-map.js"></script>


    <script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>

    <div id="container" style="height: 500px; width: 700px">
        <div id="element"></div>
    </div>

    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Multiple marker groups

Multiple groups of markers can be added to the Maps by providing an array of marker configurations to the markerSettings property. Each marker group can have its own customization options defined within the markerSettings.

var map = new ej.maps.Maps({
    layers: [{
        shapeData: world_map,
        markerSettings: [{
            visible: true,
            shape: 'Diamond',
            height: 15,
            fill: "green",
            width: 15,
            dataSource: [
                { 
                    latitude: 37.0000, longitude: -120.0000, name:'California',
                },
                { 
                    latitude: 40.7127, longitude: -74.0059, name:"New York"
                },
                {
                    latitude: 42, longitude: -93, name:'Iowa'                    
                }
            ]
        },
        {
            visible: true,
            dataSource: [{
                latitude: 19.228825, longitude: 72.854118, name: "Mumbai"
            }, {
                latitude: 28.610001, longitude: 77.230003, name: "Delhi"
            }, {
                latitude: 13.067439, longitude: 80.237617, name: "Chennai"
            }],
            shape: 'Circle',
            fill: "blue",
            height: 10,
            width: 10
        }]
    }]
});
map.appendTo('#element');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Maps</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">

    <script src="world-map.js"></script>

    <script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>

    <div id="container" style="height: 500px; width: 700px">
        <div id="element"></div>
    </div>

    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Customize marker shapes from data source

Bind different colors and shapes to the marker from data source

Using the shapeValuePath and colorValuePath properties, apply the color and shape of the marker from the given data source. Bind the data source to the dataSource property of the markerSettings and set the field names that contains the shape and color values in the data source to the shapeValuePath and colorValuePath properties. A default marker object is represented by a balloon shape. To set various shapes to the marker object by using the shape property in markerSettings.

The following shapes are used for the marker object.

  • Circle
  • Rectangle
  • Balloon
  • Cross
  • Polyline
  • Diamond
  • Star
  • Triangle
  • HorizontalLine
  • VerticalLine
  • pentagon
var map = new ej.maps.Maps({
    layers: [{
         shapeData: world_map,
        markerSettings: [{
            visible: true,
            shapeValuePath:'shape',
            colorValuePath:'color',
            dataSource: [
                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe', color:'red', shape:'Triangle' },
                { latitude: 59.88893689676585, longitude: -109.3359375, name:'North America',
                color:'blue', shape:'Pentagon' },
                { latitude: -6.64607562172573, longitude: -55.54687499999999, name:'South America',
                color:'green', shape:'InvertedTriangle' }
            ]
        }]
    }]
});
map.appendTo('#element');
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Maps</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    
    <script src="world-map.js"></script>
  
    
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container" style="height: 500px; width: 700px">
        <div id="element"></div>
    </div>
   
<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Setting value path from the data source

The latitude and longitude values are used to determine the location of each marker in the Maps. The latitudeValuePath and longitudeValuePath properties are used to specify the value path that presents in the data source of the marker. In the following example, the field name from the data source is set to the latitudeValuePath and longitudeValuePath properties.

var map = new ej.maps.Maps({
      layers: [{
        shapeData: world_map,
        markerSettings: [{
            visible: true,
            latitudeValuePath: 'latitude',
            longitudeValuePath: 'longitude',
            dataSource: [
                { latitude: 49.95121990866204, longitude: 18.468749999999998 },
                { latitude: 59.88893689676585, longitude: -109.3359375},
                { latitude: -6.64607562172573, longitude: -55.54687499999999 }
            ]
        }],
    }]
});
map.appendTo('#element');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Maps</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">

    <script src="world-map.js"></script>

    <script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>

    <div id="container" style="height: 500px; width: 700px">
        <div id="element"></div>
    </div>


    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Setting different sizes for markers individually

The size of the markers in a marker group can be customized using the widthValuePath and heightValuePath properties, which allow the user to change the width and height of the markers based on values from the given data source. Bind the data source to the dataSource property of the markerSettings, and specify the field names containing the width and height values in the data source for the widthValuePath and heightValuePath properties.

var map = new ej.maps.Maps({
    layers: [{
        shapeData: world_map,
        markerSettings: [{
            visible: true,
            shape: 'Circle',
            widthValuePath: 'width',
            heightValuePath: 'height',
            dataSource: [
                {
                    latitude: 49.95121990866204,
                    longitude: 18.468749999999998,
                    width: 30,
                    height: 30,
                },
                {
                    latitude: 59.88893689676585,
                    longitude: -109.3359375,
                    width: 20,
                    height: 20,
                },
                {
                    latitude: -6.64607562172573,
                    longitude: -55.54687499999999,
                    width: 10,
                    height: 10,
                },
            ],
        }],
    }]
});
map.appendTo('#element');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Maps</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">

    <script src="world-map.js"></script>

    <script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>

    <div id="container" style="height: 500px; width: 700px">
        <div id="element"></div>
    </div>


    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Repositioning the marker using drag and drop

The markers on the map can be dragged and dropped to change their position. To enable marker drag and drop, set the enableDrag property to true in the markerSettings property.

var map = new ej.maps.Maps({
    layers: [{
        shapeData: world_map,
        shapeSettings: {
            fill: '#C3E6ED'
        },
        markerSettings: [
            {
                enableDrag: true,
                dataSource: [
                    { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'MarkerOne' },
                    { latitude: 59.88893689676585, longitude: -109.3359375, name:'MarkerTwo'},
                    { latitude: -6.64607562172573, longitude: -55.54687499999999 , name:'MarkerThree'},
                    { latitude: 23.644385824912135, longitude: 77.83189239539234  , name:'MarkerFour'},
                    { latitude: 63.66569332894224, longitude: 98.2225173953924 , name:'MarkerFive'}
                ],
                visible: true,
                animationDuration: 0,
                shape: 'Balloon',
                width: 20,
                height: 20,
                border: { width: 2, color: '#285255' },
                 tooltipSettings: {
                     visible: true,
                     valuePath: 'name',
                 }
            },
        ]
    }]
});
map.appendTo('#element');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Maps</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">

    <script src="world-map.js"></script>

    <script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>

    <div id="container" style="height: 500px; width: 700px">
        <div id="element"></div>
    </div>


    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

The data of the drag and dropped marker in the marker data source can be customized using the markerDragStart and markerDragEnd events. When you change the appropriate marker data, the tooltip and legend item text of that marker are automatically updated. The following properties are available in the event argument of the marker drag events.

Argument Name Description
dataIndex It represents the index of the data of the dragged marker in the marker data source.
latitude It represents the latitude coordinate point of the dragged marker.
longitude It represents the longitude coordinate point for the dragged marker.
markerIndex It represents the index of the marker setting.
layerIndex It represents the index of the layer in which the marker belongs.
name It represents the name of the event.
x It represents the horizontal location of the mouse pointer on the map when the drag action is performed.
y It represents the vertical location of the mouse pointer on the map when the drag action is performed.

The following example shows how to use marker drag events to customize the data of the drag and dropped marker in the marker data source.

var map = new ej.maps.Maps({
    legendSettings:{
        visible:true,
        type:'Markers',
        shape:'Circle',
        shapeWidth:10,
        shapeHeight:10,
        fill:'#FF471A',
        shapeBorder: { width: 2, color: '#285255' },
    },
    markerDragStart: function(args){
       // When the marker begins to move on the map, the event is triggered.
    },
    markerDragEnd: function(args) {
       // When the marker on the map stops dragging, the event is triggered.
       var mapsInstance = document.getElementById('element').ej2_instances[0];
       mapsInstance.layers[args.layerIndex].markerSettings[args.markerIndex].dataSource[args.dataIndex].name = 'Dragged Marker ' + (args.dataIndex + 1);
       mapsInstance.refresh();
    },
    layers: [{
        shapeData: world_map,
        shapeSettings: {
            fill: '#C3E6ED'
        },
        markerSettings: [
            {
                enableDrag: true,
                legendText:'name',
                dataSource: [
                     { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'MarkerOne' },
                     { latitude: 59.88893689676585, longitude: -109.3359375, name:'MarkerTwo'},
                     { latitude: -6.64607562172573, longitude: -55.54687499999999 , name:'MarkerThree'},
                     { latitude: 23.644385824912135, longitude: 77.83189239539234  , name:'MarkerFour'},
                     { latitude: 63.66569332894224, longitude: 98.2225173953924 , name:'MarkerFive'}
                ],
                visible: true,
                animationDuration: 0,
                shape: 'Balloon',
                width: 20,
                height: 20,
                border: { width: 2, color: '#285255' },
                 tooltipSettings: {
                     visible: true,
                     valuePath: 'name',
                 }
            },
        ]
    }]
});
map.appendTo('#element');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Maps</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">

    <script src="world-map.js"></script>

    <script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>

    <div id="container" style="height: 500px; width: 700px">
        <div id="element"></div>
    </div>


    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Marker zooming

The Maps can be initially scaled to fit all markers within the visible area. This can be achieved by setting the shouldZoomInitially property in zoomSettings to true.

var map = new ej.maps.Maps({
    zoomSettings: {
        enable: true,
        shouldZoomInitially: true,
        toolbarSettings: {
            horizontalAlignment: 'Near'
        }
    },
    layers: [{
        shapeData: world_map,
        markerSettings: [{
            visible: true,
            dataSource: [
                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                { latitude: 59.88893689676585, longitude: -109.3359375, name:'North America' },
                { latitude: -6.64607562172573, longitude: -55.54687499999999, name:'South America'}
            ]
        }],
    }]
});
map.appendTo('#element');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Maps</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">

    <script src="world-map.js"></script>

    <script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>

    <div id="container" style="height: 500px; width: 700px">
        <div id="element"></div>
    </div>


    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Marker clustering

The Maps component provides support to cluster markers when they overlap each other. The number displayed on a cluster indicates how many overlapping markers it contains. When zooming in on a cluster location, the cluster count decreases as individual markers become visible. When zooming out, overlapping markers are grouped again, increasing the cluster count.

To enable clustering for markers within a layer, set the allowClustering property of markerClusterSettings in the layers to true. Customization of clustering can be done using the markerClusterSettings property.

var maps = new ej.maps.Maps({
     useGroupingSeparator: true,
        format: 'n',
        zoomSettings: {
            enable: true
        },
        titleSettings: {
            text: 'Top 13 largest cities in the World',
            textStyle: {
                size: '16px'
            }
        },
        layers: [
            {
                shapeData: new ej.maps.MapAjax('//ej2.syncfusion.com/javascript/demos/src/maps/map-data/world-map.json'),
                shapeSettings: {
                    fill: '#C1DFF5'
                },
                markerClusterSettings: {
                    allowClustering: true,
                    shape: 'Circle',
                    height: 40,
                    width: 40,
                    labelStyle : { color: 'white'},
                },
                markerSettings: [
                    {
                        visible: true,
                        dataSource: cluster,
                        shape: 'Balloon',
                        tooltipSettings: {
                            visible: true,
                            valuePath: 'area',
                            format: 'City: ${city} <br> Area: ${area}'
                        },
                        height: 20,
                        width: 20,
                        animationDuration: 0
                    },

                ]
            }
        ]
	});
    maps.appendTo('#container');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Maps</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">

    <script src="cluster.js"></script>

    <script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>

    <div id="container" style="height: 500px; width: 700px">
        <div id="element"></div>
    </div>

    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Customization of marker cluster

The following properties are available to customize the marker clustering in the Maps component.

  • border - To customize the color, width and opacity of the border of cluster in Maps.
  • connectorLineSettings - To customize the connector line in cluster separating the markers.
  • dashArray - To customize the dash array for the marker cluster in Maps.
  • fill - Applies the color of the cluster in Maps.
  • height - To customize the height of the marker cluster in Maps.
  • imageUrl - To customize the URL path for the marker cluster when the cluster shape is set as image in Maps.
  • labelStyle - To customize the text in marker cluster.
  • offset - To customize the offset position for the marker cluster in Maps.
  • opacity - To customize the opacity of the marker cluster.
  • shape - To customize the shape for the cluster of markers.
  • width - To customize the width of the marker cluster in Maps.
var maps = new ej.maps.Maps({
    zoomSettings: {
        enable: true
    },
    layers: [{
        shapeData: new ej.maps.MapAjax('//ej2.syncfusion.com/javascript/demos/src/maps/map-data/world-map.json'),
        shapeSettings: {
            fill: '#C1DFF5'
        },
        markerClusterSettings: {
            allowClustering: true,
            allowClusterExpand: true,
            shape: 'Circle',
            height: 40,
            width: 40,
            labelStyle : { color: 'white'},
            opacity: 0.9,
            fill: 'green',
            connectorLineSettings: {
                color: 'orange',
                opacity: 0.8,
                width: 2
            }
        },
        markerSettings: [{
            visible: true,
            dataSource: cluster,
            shape: 'Balloon',
            tooltipSettings: {
                format: 'City: ${city} <br> Area: ${area}',
                visible: true,
                valuePath: 'area',
            },
            height: 20,
            width: 20,
            animationDuration: 0
        }]
    }]
	});
    maps.appendTo('#container');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Maps</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">

    <script src="cluster.js"></script>

    <script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>

    <div id="container" style="height: 500px; width: 700px">
        <div id="element"></div>
    </div>


    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Marker cluster expand

The cluster is formed by grouping an identical and non-identical marker from the surrounding area. By clicking on the cluster and setting the allowClusterExpand property in markerClusterSettings as true to expand the identical markers. If zoom in any of the locations of the cluster, the number on the cluster will decrease and the overlapping marker will be split into an individual marker on the map. When performing zoom out, it will increase the marker count and then cluster it again.

var map = new ej.maps.Maps({
    zoomSettings: {
        enable: true,
        mouseWheelZoom : true,
    },
    layers: [{
        shapeData: world_map,
        markerClusterSettings: {
            allowClustering: true,
            allowClusterExpand : true,
            shape: 'Circle',
            height: 40,
            width: 40,
            labelStyle : { color: 'white'},
        },
        markerSettings: [{
            visible: true,
            dataSource: [
                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                { latitude: 59.88893689676585, longitude: -109.3359375, name:'North America' },
                { latitude: -6.64607562172573, longitude: -55.54687499999999, name:'South America'}
            ]
        }],
    }]
});
map.appendTo('#element');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Maps</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">

    <script src="world-map.js"></script>

    <script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>

    <div id="container" style="height: 500px; width: 700px">
        <div id="element"></div>
    </div>


    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Clustering markers within each marker group

Marker clustering can be enabled for each marker group in the map by using the clusterSettings property within the markerSettings property in the layers. This allows for individual customization of clusters for each marker group which group markers that are located near each other to reduce clutter and improve readability. When the allowClustering property is set to true, the markers within each group are clustered and visually represented as separate clusters. As users zoom in, the clusters expand to reveal individual markers, enabling more detailed exploration. Clusters can also be expanded manually by setting the allowClusterExpand property to true. The appearance of the clusters and their expansion behavior can be customized using the clusterSettings property, similar to the markerClusterSettings property, as explained in the sections above.

When the clusterSettings property is enabled for an individual marker group, the markerClusterSettings property within the layers becomes ineffective.

var maps = new ej.maps.Maps({
    zoomSettings: {
        enable: true
    },
    titleSettings: {
        text: 'Attractive places around the world',
        textStyle: {
            size: '16px'
        }
    },
    layers: [
        {
            shapeData: world_map,
            shapeSettings: {
                fill: '#C3E6ED'
            },
            markerSettings: [
                {
                    clusterSettings: {
                        allowClustering: true,
                        allowDeepClustering: false,
                        allowClusterExpand: true,
                        labelStyle: {
                            color: 'white',
                            size: '10px'
                        },
                        shape: 'Image',
                        height: 40, width: 40,
                        imageUrl: './images/cluster-france.svg'
                    },
                    visible: true,
                    dataSource: [
                        { latitude: 48.8584, longitude: 2.2945, name: 'Eiffel Tower', state: 'Paris', country: 'France' },
                        { latitude: 48.8606, longitude: 2.3376, name: 'Louvre Museum', state: 'Paris', country: 'France' },
                        { latitude: 48.8529, longitude: 2.3500, name: 'Notre-Dame Cathedral', state: 'Paris', country: 'France' },
                        { latitude: 48.6360, longitude: 1.5115, name: 'Mont Saint-Michel', state: 'Normandy', country: 'France' }
                    ],
                    shape: 'Circle',
                    height: 15,
                    width: 15,
                    fill: '#b38600',
                    border: {
                        color: '#e6f2ff',
                        width: 2
                    },
                    tooltipSettings: {
                        visible: true,
                        valuePath: 'name',
                        format: '<b>Name:</b> ${name} <br/> <b>State:</b> ${state} <br/> <b>Country:</b> ${country}'
                    },
                    animationDuration: 0
                },
                {
                    clusterSettings: {
                        allowClustering: true,
                        allowDeepClustering: false,
                        allowClusterExpand: true,
                        shape: 'Image',
                        height: 40, width: 40,
                        labelStyle: {
                            color: 'white',
                            size: '10px'
                        },
                        imageUrl: './images/cluster-usa.svg'
                    },
                    visible: true,
                    shape: 'Circle',
                    height: 15,
                    width: 15,
                    fill: '#bf4040',
                    border: {
                        color: '#e6f2ff',
                        width: 2
                    },
                    dataSource: [
                        { latitude: 35.019028, longitude: -85.339439, name: 'Ruby Falls', state: 'Tennessee', country: 'United States of America' },
                        { latitude: 35.654613, longitude: -105.996979, name: 'Meow Wolf Santa Fe', state: 'New Mexico', country: 'United States of America' },
                        { latitude: 36.107216, longitude: -115.175804, name: 'City Center of Las Vegas', state: 'Nevada', country: 'United States of America' },
                        { latitude: 36.879047, longitude: -111.510498, name: 'Horseshoe Bend', state: 'Arizona', country: 'United States of America' },
                        { latitude: 36.011955, longitude: -113.810951, name: 'Grand Canyon West Skywalk', state: 'Arizona', country: 'United States of America' }
                    ],
                    tooltipSettings: {
                        visible: true,
                        valuePath: 'name',
                        format: '<b>Name:</b> ${name} <br/> <b>State:</b> ${state} <br/> <b>Country:</b> ${country}'
                    },
                    animationDuration: 0
                },
                {
                    clusterSettings: {
                        allowDeepClustering: false,
                        allowClusterExpand: true,
                        allowClustering: true,
                        shape: 'Image',
                        height: 40, width: 40,
                        labelStyle: {
                            size: '10px',
                            color: 'white'
                        },
                        imageUrl: './images/cluster-india.svg'
                    },
                    dataSource: [
                        { latitude: 26.985901, longitude: 75.850700, name: 'Amber Fort, Amer', state: 'Rajastan', country: 'India' },
                        { latitude: 22.957390, longitude: 77.625275, name: 'Bhimbetka, Raisen District', state: 'Madhya Pradesh', country: 'India' },
                        { latitude: 26.809330, longitude: 75.540527, name: 'Bagru Fort, Bagru', state: 'Rajasthan', country: 'India' },
                        { latitude: 25.489504, longitude: 80.330116, name: 'Kalinjar Fort, Banda', state: 'Uttar Pradesh', country: 'India' },
                        { latitude: 27.988890, longitude: 76.388336, name: 'Neemrana', state: 'Rajasthan', country: 'India' }
                    ],
                    visible: true,
                    shape: 'Circle',
                    fill: '#00b3b3',
                    border: {
                        color: '#e6f2ff',
                        width: 2
                    },
                    height: 15,
                    width: 15,
                    tooltipSettings: {
                        visible: true,
                        format: '<b>Name:</b> ${name} <br/> <b>State:</b> ${state} <br/> <b>Country:</b> ${country}',
                        valuePath: 'name'
                    },
                    animationDuration: 0
                }
            ]
        }
    ]
});
maps.appendTo('#container');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Maps</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">

    <script src="world-map.js"></script>
    <script src="cluster.js"></script>

    <script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>

    <div id="container" style="height: 500px; width: 700px">
        <div id="element"></div>
    </div>

    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Tooltip for marker

Tooltips are used to display additional information about a marker on mouse hover or touch end events. This can be enabled for markers by setting the visible property or tooltipSettings to true. The valuePath property in the tooltipSettings specifies the field name from the data source whose value will be displayed as the tooltip text.

var map = new ej.maps.Maps({
    layers: [
        {
            shapeData: usa_map,
            markerSettings: [
                {
                    dataSource: [
                        { latitude: 40.7424509, longitude: -74.0081468, city: 'New York' }
                    ],
                    visible:true,
                    shape:'Circle',
                    fill:'white',
                    width:3,
                    animationDuration:0,
                    border: { width:2, color:'green'},
                    tooltipSettings: {
                        visible: true,
                        valuePath:'city'
                    }
                }
            ]
        }
    ],
    height: '450px',
    width: '700px'
});
map.appendTo('#element');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Maps</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <script src="usa.js"></script>
    <script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>

    <div id="container" style="height: 500px; width: 700px">
        <div id="element"></div>
    </div>


    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Add different types of markers

Different marker objects can be added to the Maps component using the marker settings. To update different marker settings in Maps, please follow the given steps:

Step 1:

Initialize the Maps component with marker settings. Here, a marker has been added with specified latitude and longitude of California by using the dataSource property. To customize the shape of the marker using the shape property and change the border color and width of the marker using the border property as mentioned in the following example.

var map = new ej.maps.Maps({
    //Initializing Map with Marker settings
    layers: [
        {
            shapeData: world_map,
            markerSettings: [
                {
                    dataSource: [
                       { latitude: 40.7424509, longitude: -74.0081468, city: 'New York' }
                    ],
                    visible:true,
                    shape:'Circle',
                    fill:'white',
                    width:3,
                    animationDuration:0,
                    border:{width:2,color:'#333'}
                }
            ]
        }
  ]
});
map.appendTo('#element');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Maps</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <script src="world-map.js"></script>

    <script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>

    <div id="container" style="height: 500px; width: 700px">
        <div id="element"></div>
    </div>


    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Step 2:

Customize the above option for n number of markers as mentioned in the following example.

var map = new ej.maps.Maps({
    //Initializing Map with Marker settings
    layers: [
        {
            shapeData: world_map,
            markerSettings: [
                {
                    dataSource: [
                       { latitude: 40.7424509, longitude: -74.0081468, city: 'New York' }
                    ],
                    visible:true,
                    shape:'Circle',
                    fill:'white',
                    width:3,
                    animationDuration:0,
                    border:{width:2,color:'#333'}
                }
            ]
        }
  ]
});
map.appendTo('#element');
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Maps</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">

    <script src="world-map.js"></script>

    <script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>

    <div id="container" style="height: 500px; width: 700px">
        <div id="element"></div>
    </div>

    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Markers in React Maps component

6 Feb 202624 minutes to read

This section shows how to add and customize the markers in the Maps component. The below video demonstrates the same.

Markers are visual indicators used to pinpoint specific locations on the Maps. They can display desired symbols to highlight points of interest or important geographic positions. Markers can be enabled by setting the visible property of the markerSettings to true.

Adding marker

To add the markers, the dataSource property of the markerSettings has a list of objects that contains the data for markers. Using this property, any number of markers can be added to the layers of the Maps. By default, it displays the markers based on the specified latitude and longitude in the given data source. Each data source object contains the following list of properties.

  • latitude - The latitude value that determines the vertical (Y) position of the marker.
  • longitude - The longitude value that determines the horizontal (X) position of the marker.
import { world_map } from 'world-map.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, MarkersDirective, MarkerDirective, Marker, Inject } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
                <MapsComponent >
                <Inject services={[Marker]} />
                    <LayersDirective>
                        <LayerDirective shapeData={world_map}>
                        <MarkersDirective>
                            <MarkerDirective visible={true}
                                            height={20}
                                            width={20}
                                            animationDuration={0}
                                            dataSource={[
                                                { latitude: 49.95121990866204, longitude: 18.468749999999998 },
                                                { latitude: 59.88893689676585, longitude: -109.3359375 },
                                                { latitude: -6.64607562172573, longitude: -55.54687499999999 }
                                            ]}>
                            </MarkerDirective>
                        </MarkersDirective>
                        </LayerDirective>
                    </LayersDirective>
                </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import { world_map } from 'world-map.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, MarkersDirective, MarkerDirective, Marker, Inject } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
                <MapsComponent >
                <Inject services={[Marker]} />
                    <LayersDirective>
                        <LayerDirective shapeData={world_map}>
                        <MarkersDirective>
                            <MarkerDirective visible={true}
                                            height={20}
                                            width={20}
                                            animationDuration={0}
                                            dataSource={[
                                                { latitude: 49.95121990866204, longitude: 18.468749999999998 },
                                                { latitude: 59.88893689676585, longitude: -109.3359375 },
                                                { latitude: -6.64607562172573, longitude: -55.54687499999999 }
                                            ]}>
                            </MarkerDirective>
                        </MarkersDirective>
                        </LayerDirective>
                    </LayersDirective>
                </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Adding marker template

The Marker can be added as a template in the Maps component. The template property of the markerSettings is used to set the HTML element or id of an element as a template.

import { world_map } from 'world-map.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, MarkersDirective, MarkerDirective, Marker, Inject } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
                <MapsComponent >
                <Inject services={[Marker]} />
                    <LayersDirective>
                        <LayerDirective shapeData={world_map}>
                        <MarkersDirective>
                                        <MarkerDirective visible={true}
                                            height={30}
                                            width={30}
                                            template='<div id="marker1">Europe</div>'
                                            dataSource={[{ latitude: 49.95121990866204, longitude: 18.468749999999998 }]}
                                        >
                                        </MarkerDirective>
                                        <MarkerDirective visible={true}
                                            height={30}
                                            width={30}
                                            template='<div id="marker2">North America</div>'
                                            dataSource={[{ latitude: 59.88893689676585, longitude: -109.3359375 }]}
                                        >
                                        </MarkerDirective>
                                        <MarkerDirective visible={true}
                                            height={30}
                                            width={30}
                                            template='<div id="marker3">South America</div>'
                                            dataSource={[{ latitude: -6.64607562172573, longitude: -55.54687499999999 }]}
                                        >
                                        </MarkerDirective>
                                        </MarkersDirective>
                        </LayerDirective>
                    </LayersDirective>
                </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import { world_map } from 'world-map.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, MarkersDirective, MarkerDirective, Marker, Inject } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
                <MapsComponent >
                <Inject services={[Marker]} />
                    <LayersDirective>
                        <LayerDirective shapeData={world_map}>
                        <MarkersDirective>
                                        <MarkerDirective visible={true}
                                            height={30}
                                            width={30}
                                            template='<div id="marker1">Europe</div>'
                                            dataSource={[{ latitude: 49.95121990866204, longitude: 18.468749999999998 }]}
                                        >
                                        </MarkerDirective>
                                        <MarkerDirective visible={true}
                                            height={30}
                                            width={30}
                                            template='<div id="marker2">North America</div>'
                                            dataSource={[{ latitude: 59.88893689676585, longitude: -109.3359375 }]}
                                        >
                                        </MarkerDirective>
                                        <MarkerDirective visible={true}
                                            height={30}
                                            width={30}
                                            template='<div id="marker3">South America</div>'
                                            dataSource={[{ latitude: -6.64607562172573, longitude: -55.54687499999999 }]}
                                        >
                                        </MarkerDirective>
                                        </MarkersDirective>
                        </LayerDirective>
                    </LayersDirective>
                </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Customization

The following properties are available in markerSettings to customize the Markers of the Maps component.

  • border - To customize the color, width and opacity of the border for the markers in Maps.
  • fill - To apply the color for markers in Maps.
  • dashArray - To define the pattern of dashes and gaps that is applied to the outline of the markers in Maps.
  • height - To customize the height of the markers in Maps.
  • width - To customize the width of the markers in Maps.
  • offset - To customize the position of the markers in Maps.
  • opacity - To customize the transparency of the markers in Maps.
  • animationDelay - To change the time delay in the transition for markers.
  • animationDuration - To change the time duration of animation for markers.
import { world_map } from 'world-map.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, MarkersDirective, MarkerDirective, Marker, Inject } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
                <MapsComponent >
                <Inject services={[Marker]} />
                    <LayersDirective>
                        <LayerDirective shapeData={world_map}>
                        <MarkersDirective>
                            <MarkerDirective visible={true}
                                            height={20}
                                            width={20}
                                            animationDuration={1000}
                                            animationDelay={100}
                                            opacity={0.9}
                                            shape="Balloon"
                                            dashArray="1"
                                            border={{
                                                color: 'green',
                                                width: 2
                                            }}
                                            dataSource={[
                                                { latitude: 37.0000, longitude: -120.0000, city: 'California' },
                                                { latitude: 40.7127, longitude: -74.0059, city: 'New York' },
                                                { latitude: 42, longitude: -93, city: 'Iowa' }
                                            ]}>
                            </MarkerDirective>
                        </MarkersDirective>
                        </LayerDirective>
                    </LayersDirective>
                </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import { world_map } from 'world-map.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, MarkersDirective, MarkerDirective, Marker, Inject } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
                <MapsComponent >
                <Inject services={[Marker]} />
                    <LayersDirective>
                        <LayerDirective shapeData={world_map}>
                        <MarkersDirective>
                            <MarkerDirective visible={true}
                                            height={20}
                                            width={20}
                                            animationDuration={1000}
                                            animationDelay={100}
                                            opacity={0.9}
                                            shape="Balloon"
                                            dashArray="1"
                                            border={{
                                                color: 'green',
                                                width: 2
                                            }}
                                            dataSource={[
                                                { latitude: 37.0000, longitude: -120.0000, city: 'California' },
                                                { latitude: 40.7127, longitude: -74.0059, city: 'New York' },
                                                { latitude: 42, longitude: -93, city: 'Iowa' }
                                            ]}>
                            </MarkerDirective>
                        </MarkersDirective>
                        </LayerDirective>
                    </LayersDirective>
                </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Marker shapes

The Maps component supports the following marker shapes. To set the shape of the marker, the shape property in markerSettings is used.

  • Balloon
  • Circle
  • Cross
  • Diamond
  • Image
  • Rectangle
  • Star
  • Triangle
  • VerticalLine
  • HorizontalLine

Rendering marker shape as image

To render a marker as an image in Maps, set the shape property of markerSettings as Image and specify the path of the image to imageUrl property. There is another way to render a marker as an image using the imageUrlValuePath property of the markerSettings. Bind the field name that contains the path of the image in the data source to the imageUrlValuePath property.

import { world_map } from 'world-map.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, MarkersDirective, MarkerDirective, Marker, Inject } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
                <MapsComponent >
                <Inject services={[Marker]} />
                    <LayersDirective>
                        <LayerDirective shapeData={world_map}>
                        <MarkersDirective>
                            <MarkerDirective visible={true}
                                            shape="Image"
                                            imageUrl="https://ej2.syncfusion.com/react/demos/src/maps/images/ballon.png"
                                            height={10}
                                            width={10}
                                            dataSource={[
                                                { latitude: 37.0000, longitude: -120.0000, city: 'California' },
                                                { latitude: 40.7127, longitude: -74.0059, city: 'New York' },
                                                { latitude: 42, longitude: -93, city: 'Iowa' }
                                            ]}>
                            </MarkerDirective>
                        </MarkersDirective>
                        </LayerDirective>
                    </LayersDirective>
                </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import { world_map } from 'world-map.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, MarkersDirective, MarkerDirective, Marker, Inject } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
                <MapsComponent >
                <Inject services={[Marker]} />
                    <LayersDirective>
                        <LayerDirective shapeData={world_map}>
                        <MarkersDirective>
                            <MarkerDirective visible={true}
                                            shape="Image"
                                            imageUrl="https://ej2.syncfusion.com/react/demos/src/maps/images/ballon.png"
                                            height={10}
                                            width={10}
                                            dataSource={[
                                                { latitude: 37.0000, longitude: -120.0000, city: 'California' },
                                                { latitude: 40.7127, longitude: -74.0059, city: 'New York' },
                                                { latitude: 42, longitude: -93, city: 'Iowa' }
                                            ]}>
                            </MarkerDirective>
                        </MarkersDirective>
                        </LayerDirective>
                    </LayersDirective>
                </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Multiple marker groups

Multiple groups of markers can be added to the Maps by providing an array of marker configurations to the MarkerDirective property. Each marker group can have its own customization options defined within the MarkerDirective.

import { world_map } from 'world-map.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, MarkersDirective, MarkerDirective, Marker, Inject } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
                <MapsComponent >
                <Inject services={[Marker]} />
                    <LayersDirective>
                        <LayerDirective shapeData={world_map}>
                        <MarkersDirective>
                        <MarkerDirective visible={true} shape= "Diamond" height={15} fill="green" width={15}
                                        dataSource={[
                                            { latitude: 37.0000, longitude: -120.0000, name:'California'},
                                            { latitude: 40.7127, longitude: -74.0059, name:"New York" },
                                            { latitude: 42, longitude: -93, name:'Iowa' }
                                        ]}>
                                        </MarkerDirective>
                        <MarkerDirective visible={true} height={10} width={10} fill="blue" shape= "Circle"
                                        dataSource={[
                                            { latitude: 19.228825, longitude: 72.854118, name: "Mumbai"},
                                            { latitude: 28.610001, longitude: 77.230003, name: "Delhi"},
                                            { latitude: 13.067439, longitude: 80.237617, name: "Chennai"}
                                        ]}>
                        </MarkerDirective>
                        </MarkersDirective>
                        </LayerDirective>
                    </LayersDirective>
                </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import { world_map } from 'world-map.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, MarkersDirective, MarkerDirective, Marker, Inject } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
                <MapsComponent >
                <Inject services={[Marker]} />
                    <LayersDirective>
                        <LayerDirective shapeData={world_map}>
                        <MarkersDirective>
                        <MarkerDirective visible={true} shape= "Diamond" height={15} fill="green" width={15}
                                        dataSource={[
                                            { latitude: 37.0000, longitude: -120.0000, name:'California'},
                                            { latitude: 40.7127, longitude: -74.0059, name:"New York" },
                                            { latitude: 42, longitude: -93, name:'Iowa' }
                                        ]}>
                                        </MarkerDirective>
                        <MarkerDirective visible={true} height={10} width={10} fill="blue" shape= "Circle"
                                        dataSource={[
                                            { latitude: 19.228825, longitude: 72.854118, name: "Mumbai"},
                                            { latitude: 28.610001, longitude: 77.230003, name: "Delhi"},
                                            { latitude: 13.067439, longitude: 80.237617, name: "Chennai"}
                                        ]}>
                        </MarkerDirective>
                        </MarkersDirective>
                        </LayerDirective>
                    </LayersDirective>
                </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Customize marker shapes from data source

Bind different colors and shapes to the marker from data source

Using the shapeValuePath and colorValuePath properties, the color and shape of the marker can be applied from the given data source. Bind the data source to the dataSource property of the markerSettings and set the field names that contains the shape and color values in the data source to the shapeValuePath and colorValuePath properties.

import { world_map } from 'world-map.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, MarkersDirective, MarkerDirective, Marker, Inject } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
                <MapsComponent >
                <Inject services={[Marker]} />
                    <LayersDirective>
                        <LayerDirective shapeData={world_map}>
                        <MarkersDirective>
                        <MarkerDirective visible={true}
                                            shape= {'Circle'} shapeValuePath= {'shape'} colorValuePath= {'color'}
                                            dataSource={[
                                                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe', color:'red', shape:'Triangle' },
                                                { latitude: 59.88893689676585, longitude: -109.3359375, name:'North America',
                                                color:'blue', shape:'Pentagon' },
                                                { latitude: -6.64607562172573, longitude: -55.54687499999999, name:'South America',
                                                color:'green', shape:'InvertedTriangle' }
                                                ]}
                                        >
                                        </MarkerDirective>
                                        </MarkersDirective>
                        </LayerDirective>
                    </LayersDirective>
                </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import { world_map } from 'world-map.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, MarkersDirective, MarkerDirective, Marker, Inject } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
                <MapsComponent >
                <Inject services={[Marker]} />
                    <LayersDirective>
                        <LayerDirective shapeData={world_map}>
                        <MarkersDirective>
                        <MarkerDirective visible={true}
                                            shape= {'Circle'} shapeValuePath= {'shape'} colorValuePath= {'color'}
                                            dataSource={[
                                                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe', color:'red', shape:'Triangle' },
                                                { latitude: 59.88893689676585, longitude: -109.3359375, name:'North America',
                                                color:'blue', shape:'Pentagon' },
                                                { latitude: -6.64607562172573, longitude: -55.54687499999999, name:'South America',
                                                color:'green', shape:'InvertedTriangle' }
                                                ]}
                                        >
                                        </MarkerDirective>
                                        </MarkersDirective>
                        </LayerDirective>
                    </LayersDirective>
                </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Setting value path from the data source

The latitude and longitude values are used to determine the location of each marker in the Maps. The latitudeValuePath and longitudeValuePath properties are used to specify the value path that presents in the data source of the marker. In the following example, the field name from the data source is set to the latitudeValuePath and longitudeValuePath properties.

import { world_map } from 'world-map.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, MarkersDirective, MarkerDirective, Marker, Inject } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
                <MapsComponent >
                <Inject services={[Marker]} />
                    <LayersDirective>
                        <LayerDirective shapeData={world_map}>
                        <MarkersDirective>
                            <MarkerDirective visible={true}
                                            latitudeValuePath = "latitude"
                                            longitudeValuePath= "longitude"
                                            dataSource={[
                                                { latitude: 49.95121990866204, longitude: 18.468749999999998 },
                                                { latitude: 59.88893689676585, longitude: -109.3359375},
                                                { latitude: -6.64607562172573, longitude: -55.54687499999999 }
                                            ]}>
                            </MarkerDirective>
                        </MarkersDirective>
                        </LayerDirective>
                    </LayersDirective>
                </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import { world_map } from 'world-map.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, MarkersDirective, MarkerDirective, Marker, Inject } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
                <MapsComponent >
                <Inject services={[Marker]} />
                    <LayersDirective>
                        <LayerDirective shapeData={world_map}>
                        <MarkersDirective>
                            <MarkerDirective visible={true}
                                            latitudeValuePath = "latitude"
                                            longitudeValuePath= "longitude"
                                            dataSource={[
                                                { latitude: 49.95121990866204, longitude: 18.468749999999998 },
                                                { latitude: 59.88893689676585, longitude: -109.3359375},
                                                { latitude: -6.64607562172573, longitude: -55.54687499999999 }
                                            ]}>
                            </MarkerDirective>
                        </MarkersDirective>
                        </LayerDirective>
                    </LayersDirective>
                </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Setting different sizes for markers individually

The size of the markers in a marker group can be customized using the widthValuePath and heightValuePath properties, which allow the user to change the width and height of the markers based on values from the given data source. Bind the data source to the dataSource property of the markerSettings, and specify the field names containing the width and height values in the data source for the widthValuePath and heightValuePath properties.

import { world_map } from 'world-map.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, MarkersDirective, MarkerDirective, Marker, Inject } from '@syncfusion/ej2-react-maps';
export function App() {
    return (
        <MapsComponent >
            <Inject services={[Marker]} />
            <LayersDirective>
                <LayerDirective shapeData={world_map}>
                    <MarkersDirective>
                        <MarkerDirective visible={true}
                            shape='Circle'
                            widthValuePath='width'
                            heightValuePath='height'
                            dataSource={[
                                { latitude: 49.95121990866204, longitude: 18.468749999999998, width: 30, height: 30 },
                                { latitude: 59.88893689676585, longitude: -109.3359375, width: 20, height: 20 },
                                { latitude: -6.64607562172573, longitude: -55.54687499999999, width: 10, height: 10 }
                            ]}>
                        </MarkerDirective>
                    </MarkersDirective>
                </LayerDirective>
            </LayersDirective>
        </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import { world_map } from 'world-map.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, MarkersDirective, MarkerDirective, Marker, Inject } from '@syncfusion/ej2-react-maps';
export function App() {
    return (
        <MapsComponent >
            <Inject services={[Marker]} />
            <LayersDirective>
                <LayerDirective shapeData={world_map}>
                    <MarkersDirective>
                        <MarkerDirective visible={true}
                            shape='Circle'
                            widthValuePath='width'
                            heightValuePath='height'
                            dataSource={[
                                { latitude: 49.95121990866204, longitude: 18.468749999999998, width: 30, height: 30 },
                                { latitude: 59.88893689676585, longitude: -109.3359375, width: 20, height: 20 },
                                { latitude: -6.64607562172573, longitude: -55.54687499999999, width: 10, height: 10 }
                            ]}>
                        </MarkerDirective>
                    </MarkersDirective>
                </LayerDirective>
            </LayersDirective>
        </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Repositioning the marker using drag and drop

The markers on the map can be dragged and dropped to change their position. To enable marker drag and drop, set the enableDrag property to true in the markerSettings property.

import { world_map } from 'world-map.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, MapsTooltip, Inject, MarkersDirective, MarkerDirective, Marker } from '@syncfusion/ej2-react-maps';
export function App() {
    return(<div><MapsComponent>
        <Inject services={[MapsTooltip, Marker]} />
        <LayersDirective>
          <LayerDirective
            shapeData={world_map}
            shapeSettings={{
              fill: '#C3E6ED',
            }}
          >
            <MarkersDirective>
              <MarkerDirective
                enableDrag={true}
                visible={true}
                animationDuration={0}
                dataSource={[
                  {
                    latitude: 49.95121990866204,
                    longitude: 18.468749999999998,
                    name: 'MarkerOne',
                  },
                  {
                    latitude: 59.88893689676585,
                    longitude: -109.3359375,
                    name: 'MarkerTwo',
                  },
                  {
                    latitude: -6.64607562172573,
                    longitude: -55.54687499999999,
                    name: 'MarkerThree',
                  },
                  {
                    latitude: 23.644385824912135,
                    longitude: 77.83189239539234,
                    name: 'MarkerFour',
                  },
                  {
                    latitude: 63.66569332894224,
                    longitude: 98.2225173953924,
                    name: 'MarkerFive',
                  },
                ]}
                shape="Balloon"
                width={20}
                height={20}
                border={{ width: 2, color: '#285255' }}
                tooltipSettings={{
                  visible: true,
                  valuePath: 'name',
                }}
              ></MarkerDirective>
            </MarkersDirective>
          </LayerDirective>
        </LayersDirective>
      </MapsComponent></div>);
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import { world_map } from 'world-map.ts';
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import {
  MapsComponent,
  LayersDirective,
  LayerDirective,
  MapsTooltip,
  Inject,
  MarkersDirective,
  MarkerDirective,
  Marker,
} from '@syncfusion/ej2-react-maps';

export function App() {
  return (
    <div><MapsComponent>
        <Inject services={[MapsTooltip, Marker]} />
        <LayersDirective>
          <LayerDirective
            shapeData={world_map}
            shapeSettings={{
              fill: '#C3E6ED',
            }}
          >
            <MarkersDirective>
              <MarkerDirective
                enableDrag={true}
                visible={true}
                animationDuration={0}
                dataSource={[
                  {
                    latitude: 49.95121990866204,
                    longitude: 18.468749999999998,
                    name: 'MarkerOne',
                  },
                  {
                    latitude: 59.88893689676585,
                    longitude: -109.3359375,
                    name: 'MarkerTwo',
                  },
                  {
                    latitude: -6.64607562172573,
                    longitude: -55.54687499999999,
                    name: 'MarkerThree',
                  },
                  {
                    latitude: 23.644385824912135,
                    longitude: 77.83189239539234,
                    name: 'MarkerFour',
                  },
                  {
                    latitude: 63.66569332894224,
                    longitude: 98.2225173953924,
                    name: 'MarkerFive',
                  },
                ]}
                shape="Balloon"
                width={20}
                height={20}
                border={{ width: 2, color: '#285255' }}
                tooltipSettings={{
                  visible: true,
                  valuePath: 'name',
                }}
              ></MarkerDirective>
            </MarkersDirective>
          </LayerDirective>
        </LayersDirective>
      </MapsComponent></div>
  );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

The data of the drag and dropped marker in the marker data source can be customized using the markerDragStart and markerDragEnd events. When you change the appropriate marker data, the tooltip and legend item text of that marker are automatically updated. The following properties are available in the event argument of the marker drag events.

Argument Name Description
dataIndex It represents the index of the data of the dragged marker in the marker data source.
latitude It represents the latitude coordinate point of the dragged marker.
longitude It represents the longitude coordinate point for the dragged marker.
markerIndex It represents the index of the marker setting.
layerIndex It represents the index of the layer in which the marker belongs.
name It represents the name of the event.
x It represents the horizontal location of the mouse pointer on the map when the drag action is performed.
y It represents the vertical location of the mouse pointer on the map when the drag action is performed.

The following example shows how to use marker drag events to customize the data of the drag and dropped marker in the marker data source.

import { world_map } from 'world-map.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, MapsTooltip, Inject, MarkersDirective, MarkerDirective, Marker, Legend } from '@syncfusion/ej2-react-maps';
export function App() {
    var mapInstance;
    function onMarkerDragStart(args) {
        // When the marker begins to move on the map, the event is triggered.
    };
    function onMarkerDragEnd(args) {
        // When the marker on the map stops dragging, the event is triggered.
        mapInstance.layers[args.layerIndex].markerSettings[args.markerIndex].dataSource[args.dataIndex].name = 'Dragged Marker ' + (args.dataIndex + 1);
        mapInstance.refresh();
    };
    return(<div><MapsComponent ref={m => mapInstance = m} markerDragStart={onMarkerDragStart.bind(this)} markerDragEnd={onMarkerDragEnd.bind(this)} legendSettings={{
        visible: true,
        type: 'Markers',
        shape: 'Circle',
        shapeWidth: 10,
        shapeHeight: 10,
        fill: '#FF471A',
        shapeBorder: { width: 2, color: '#285255' },
      }}>
        <Inject services={[MapsTooltip, Marker, Legend]} />
        <LayersDirective>
          <LayerDirective
            shapeData={world_map}
            shapeSettings={{
              fill: '#C3E6ED',
            }}
          >
            <MarkersDirective>
              <MarkerDirective
                enableDrag={true}
                legendText="name"
                visible={true}
                animationDuration={0}
                dataSource={[
                  {
                    latitude: 49.95121990866204,
                    longitude: 18.468749999999998,
                    name: 'MarkerOne',
                  },
                  {
                    latitude: 59.88893689676585,
                    longitude: -109.3359375,
                    name: 'MarkerTwo',
                  },
                  {
                    latitude: -6.64607562172573,
                    longitude: -55.54687499999999,
                    name: 'MarkerThree',
                  },
                  {
                    latitude: 23.644385824912135,
                    longitude: 77.83189239539234,
                    name: 'MarkerFour',
                  },
                  {
                    latitude: 63.66569332894224,
                    longitude: 98.2225173953924,
                    name: 'MarkerFive',
                  },
                ]}
                shape="Balloon"
                width={20}
                height={20}
                border={{ width: 2, color: '#285255' }}
                tooltipSettings={{
                  visible: true,
                  valuePath: 'name',
                }}
              ></MarkerDirective>
            </MarkersDirective>
          </LayerDirective>
        </LayersDirective>
      </MapsComponent></div>);
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import { world_map } from 'world-map.ts';
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import {
  MapsComponent,
  LayersDirective,
  LayerDirective,
  MapsTooltip,
  Inject,
  Legend,
  MarkersDirective,
  MarkerDirective,
  IMarkerDragEvents,
  Marker
} from '@syncfusion/ej2-react-maps';

export function App() {
    let mapInstance: MapsComponent;
    function onMarkerDragStart(args: IMarkerDragEvents): void {
        // When the marker begins to move on the map, the event is triggered.
    }
    function onMarkerDragEnd(args: IMarkerDragEvents) : void {
        // When the marker on the map stops dragging, the event is triggered.
        mapInstance.layers[args.layerIndex].markerSettings[
          args.markerIndex
        ].dataSource[args.dataIndex].name =
          'Dragged Marker ' + (args.dataIndex + 1);
        mapInstance.refresh();
    }
  return (
    <div><MapsComponent ref={m => mapInstance = m} markerDragStart={onMarkerDragStart.bind(this)} markerDragEnd={onMarkerDragEnd.bind(this)} legendSettings={{
        visible: true,
        type: 'Markers',
        shape: 'Circle',
        shapeWidth: 10,
        shapeHeight: 10,
        fill: '#FF471A',
        shapeBorder: { width: 2, color: '#285255' },
      }}>
        <Inject services={[MapsTooltip, Marker, Legend]} />
        <LayersDirective>
          <LayerDirective
            shapeData={world_map}
            shapeSettings={{
              fill: '#C3E6ED',
            }}
          >
            <MarkersDirective>
              <MarkerDirective
                enableDrag={true}
                legendText="name"
                visible={true}
                animationDuration={0}
                dataSource={[
                  {
                    latitude: 49.95121990866204,
                    longitude: 18.468749999999998,
                    name: 'MarkerOne',
                  },
                  {
                    latitude: 59.88893689676585,
                    longitude: -109.3359375,
                    name: 'MarkerTwo',
                  },
                  {
                    latitude: -6.64607562172573,
                    longitude: -55.54687499999999,
                    name: 'MarkerThree',
                  },
                  {
                    latitude: 23.644385824912135,
                    longitude: 77.83189239539234,
                    name: 'MarkerFour',
                  },
                  {
                    latitude: 63.66569332894224,
                    longitude: 98.2225173953924,
                    name: 'MarkerFive',
                  },
                ]}
                shape="Balloon"
                width={20}
                height={20}
                border={{ width: 2, color: '#285255' }}
                tooltipSettings={{
                  visible: true,
                  valuePath: 'name',
                }}
              ></MarkerDirective>
            </MarkersDirective>
          </LayerDirective>
        </LayersDirective>
      </MapsComponent></div>
  );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Marker zooming

The Maps can be initially scaled to fit all markers within the visible area. This can be achieved by setting the shouldZoomInitially property in zoomSettings to true.

import { world_map } from 'world-map.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, MarkersDirective, MarkerDirective, Marker, Inject, Zoom } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
                <MapsComponent  zoomSettings= {{enable: true, toolbarSettings: { horizontalAlignment:'Near' }, shouldZoomInitially: true}}>
                <Inject services={[Marker, Zoom]} />
                    <LayersDirective>
                        <LayerDirective shapeData={world_map}>
                        <MarkersDirective>
                        <MarkerDirective visible={true}
                                            shape= {'Circle'}
                                            dataSource={[
                                                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                                                { latitude: 59.88893689676585, longitude: -109.3359375, name:'North America' },
                                                { latitude: -6.64607562172573, longitude: -55.54687499999999, name:'South America'}
                                                ]}
                                        >
                                        </MarkerDirective>
                                        </MarkersDirective>
                        </LayerDirective>
                    </LayersDirective>
                </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import { world_map } from 'world-map.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, MarkersDirective, MarkerDirective, Marker, Inject, Zoom } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
                <MapsComponent  zoomSettings= {{enable: true, toolbarSettings: { horizontalAlignment:'Near' }, shouldZoomInitially: true}}>
                <Inject services={[Marker, Zoom]} />
                    <LayersDirective>
                        <LayerDirective shapeData={world_map}>
                        <MarkersDirective>
                        <MarkerDirective visible={true}
                                            shape= {'Circle'}
                                            dataSource={[
                                                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                                                { latitude: 59.88893689676585, longitude: -109.3359375, name:'North America' },
                                                { latitude: -6.64607562172573, longitude: -55.54687499999999, name:'South America'}
                                                ]}
                                        >
                                        </MarkerDirective>
                                        </MarkersDirective>
                        </LayerDirective>
                    </LayersDirective>
                </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Marker clustering

The Maps component provides support to cluster markers when they overlap each other. The number displayed on a cluster indicates how many overlapping markers it contains. When zooming in on a cluster location, the cluster count decreases as individual markers become visible. When zooming out, overlapping markers are grouped again, increasing the cluster count.

To enable clustering for markers, set the allowClustering property of markerClusterSettings to true. Customization of clustering can be done using the markerClusterSettings.

import { world_map } from 'world-map.ts';
import { cluster } from 'marker-cluster.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, MarkersDirective, MarkerDirective, Marker, Inject, MapsTooltip, Zoom } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
                <MapsComponent  useGroupingSeparator={true} format='n' zoomSettings={{ enable: true  }} titleSettings={{ text: 'Top 13 largest cities in the World', textStyle: { size: '16px' } }}>
                    <Inject services={[Marker, MapsTooltip, Zoom]} />
                    <LayersDirective>
                        <LayerDirective shapeData={world_map} shapeSettings={{ fill: '#C1DFF5' }} markerClusterSettings={{ allowClustering: true, shape: 'Circle', height: 30, width: 30, labelStyle: { color: 'white' }, }}>
                            <MarkersDirective>
                                <MarkerDirective visible={true} dataSource={cluster} shape='Balloon' tooltipSettings={{ visible: true, valuePath: 'area', }} height={15} width={15} animationDuration={0}>
                                </MarkerDirective>
                            </MarkersDirective>
                        </LayerDirective>
                    </LayersDirective>
                </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import { world_map } from 'world-map.ts';
import { cluster } from 'marker-cluster.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, MarkersDirective, MarkerDirective, Marker, Inject, MapsTooltip, Zoom } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
                <MapsComponent  useGroupingSeparator={true} format='n' zoomSettings={{ enable: true  }} titleSettings={{ text: 'Top 13 largest cities in the World', textStyle: { size: '16px' } }}>
                    <Inject services={[Marker, MapsTooltip, Zoom]} />
                    <LayersDirective>
                        <LayerDirective shapeData={world_map} shapeSettings={{ fill: '#C1DFF5' }} markerClusterSettings={{ allowClustering: true, shape: 'Circle', height: 30, width: 30, labelStyle: { color: 'white' }, }}>
                            <MarkersDirective>
                                <MarkerDirective visible={true} dataSource={cluster} shape='Balloon' tooltipSettings={{ visible: true, valuePath: 'area', }} height={15} width={15} animationDuration={0}>
                                </MarkerDirective>
                            </MarkersDirective>
                        </LayerDirective>
                    </LayersDirective>
                </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Customization of marker cluster

The following properties are available to customize the marker clustering in the Maps component.

  • border - To customize the color, width and opacity of the border of cluster in Maps.
  • connectorLineSettings - To customize the connector line in cluster separating the markers.
  • dashArray - To customize the dash array for the marker cluster in Maps.
  • fill - Applies the color of the cluster in Maps.
  • height - To customize the height of the marker cluster in Maps.
  • imageUrl - To customize the URL path for the marker cluster when the cluster shape is set as image in Maps.
  • labelStyle - To customize the text in marker cluster.
  • offset - To customize the offset position for the marker cluster in Maps.
  • opacity - To customize the opacity of the marker cluster.
  • shape - To customize the shape for the cluster of markers.
  • width - To customize the width of the marker cluster in Maps.
import { world_map } from 'world-map.ts';
import { cluster } from 'marker-cluster.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, MarkersDirective, Point, MarkerDirective, Marker, Inject, MapsTooltip, Zoom } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
                <MapsComponent  useGroupingSeparator={true} format='n' zoomSettings={{ enable: true  }} titleSettings={{ text: 'Top 13 largest cities in the World', textStyle: { size: '16px' } }}>
                    <Inject services={[Marker, MapsTooltip, Zoom]} />
                    <LayersDirective>
                        <LayerDirective shapeData={world_map} shapeSettings={{ fill: '#C1DFF5' }} markerClusterSettings={{  
                            allowClustering: true,
                            allowClusterExpand: true,
                            shape: 'Circle',
                            height: 40,
                            width: 40,
                            labelStyle : { color: 'white'},
                            offset: new Point(10, 20),
                            opacity: 0.9,
                            fill: 'green',
                            connectorLineSettings: {
                                color: 'orange',
                                opacity: 0.8,
                                width: 2
                            }
                           }}>
                            <MarkersDirective>
                                <MarkerDirective visible={true} dataSource={cluster} shape='Balloon' tooltipSettings={{ visible: true, valuePath: 'area', }} height={15} width={15} animationDuration={0}>
                                </MarkerDirective>
                            </MarkersDirective>
                        </LayerDirective>
                    </LayersDirective>
                </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import { world_map } from 'world-map.ts';
import { cluster } from 'marker-cluster.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, MarkersDirective, Point, MarkerDirective, Marker, Inject, MapsTooltip, Zoom } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
                <MapsComponent  useGroupingSeparator={true} format='n' zoomSettings={{ enable: true  }} titleSettings={{ text: 'Top 13 largest cities in the World', textStyle: { size: '16px' } }}>
                    <Inject services={[Marker, MapsTooltip, Zoom]} />
                    <LayersDirective>
                        <LayerDirective shapeData={world_map} shapeSettings={{ fill: '#C1DFF5' }} markerClusterSettings={{  
                            allowClustering: true,
                            allowClusterExpand: true,
                            shape: 'Circle',
                            height: 40,
                            width: 40,
                            labelStyle : { color: 'white'},
                            offset: new Point(10, 20),
                            opacity: 0.9,
                            fill: 'green',
                            connectorLineSettings: {
                                color: 'orange',
                                opacity: 0.8,
                                width: 2
                            }
                           }}>
                            <MarkersDirective>
                                <MarkerDirective visible={true} dataSource={cluster} shape='Balloon' tooltipSettings={{ visible: true, valuePath: 'area', }} height={15} width={15} animationDuration={0}>
                                </MarkerDirective>
                            </MarkersDirective>
                        </LayerDirective>
                    </LayersDirective>
                </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Expanding the marker cluster

The cluster is formed by grouping an identical and non-identical marker from the surrounding area. By clicking on the cluster and setting the allowClusterExpand property in markerClusterSettings as true to expand the identical markers. If zoom in any of the locations of the cluster, the number on the cluster will decrease and the overlapping marker will be split into an individual marker on the map. When performing zoom out, it will increase the marker count and then cluster it again.

import { world_map } from 'world-map.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, MarkersDirective, MarkerDirective, Marker, Inject, Zoom } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
                <MapsComponent  zoomSettings= {{enable: true, mouseWheelZoom : true }}>
                    <Inject services={[Marker, Zoom]} />
                    <LayersDirective>
                        <LayerDirective shapeData={world_map} markerClusterSettings={{ allowClustering: true,  allowClusterExpand: true,shape: 'Circle', height: 40, width: 40, labelStyle: { color: 'white' }, }}>
                            <MarkersDirective>
                                <MarkerDirective visible={true} dataSource={[
                                                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                                                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                                                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                                                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                                                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                                                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                                                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                                                { latitude: 59.88893689676585, longitude: -109.3359375, name:'North America' },
                                                { latitude: -6.64607562172573, longitude: -55.54687499999999, name:'South America'}
                                                ]}  animationDuration={0}>
                                </MarkerDirective>
                            </MarkersDirective>
                        </LayerDirective>
                    </LayersDirective>
                </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import { world_map } from 'world-map.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, MarkersDirective, MarkerDirective, Marker, Inject, Zoom } from '@syncfusion/ej2-react-maps';
export function App() {
    return(
                <MapsComponent  zoomSettings= {{enable: true, mouseWheelZoom : true }}>
                    <Inject services={[Marker, Zoom]} />
                    <LayersDirective>
                        <LayerDirective shapeData={world_map} markerClusterSettings={{ allowClustering: true,  allowClusterExpand: true,shape: 'Circle', height: 40, width: 40, labelStyle: { color: 'white' }, }}>
                            <MarkersDirective>
                                <MarkerDirective visible={true} dataSource={[
                                                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                                                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                                                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                                                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                                                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                                                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                                                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                                                { latitude: 59.88893689676585, longitude: -109.3359375, name:'North America' },
                                                { latitude: -6.64607562172573, longitude: -55.54687499999999, name:'South America'}
                                                ]}  animationDuration={0}>
                                </MarkerDirective>
                            </MarkersDirective>
                        </LayerDirective>
                    </LayersDirective>
                </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Clustering markers within each marker group

Marker clustering can be enabled for each marker group in the map by using the clusterSettings property within the markerSettings property in the layers. This allows for individual customization of clusters for each marker group which group markers that are located near each other to reduce clutter and improve readability. When the allowClustering property is set to true, the markers within each group are clustered and visually represented as separate clusters. As users zoom in, the clusters expand to reveal individual markers, enabling more detailed exploration. Clusters can also be expanded manually by setting the allowClusterExpand property to true. The appearance of the clusters and their expansion behavior can be customized using the clusterSettings property, similar to the markerClusterSettings property, as explained in the sections above.

When the clusterSettings property is enabled for an individual marker group, the markerClusterSettings property within the layers becomes ineffective.

import { world_map } from 'world-map.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, MarkersDirective, MarkerDirective, Marker, Inject, MapsTooltip, Zoom } from '@syncfusion/ej2-react-maps';
export function App() {
    return (
        <MapsComponent id="maps"
            titleSettings={{ text: 'Attractive places around the world', textStyle: { size: '16px', fontFamily: 'inherit' } }}
            zoomSettings={{
                enable: true,
                toolbarSettings: {
                    buttonSettings: {
                        toolbarItems: ['Zoom', 'ZoomIn', 'ZoomOut', 'Pan', 'Reset']
                    }
                }
            }}>
            <Inject services={[Marker, MapsTooltip, Zoom]} />
            <LayersDirective>
                <LayerDirective shapeData={world_map} >
                    <MarkersDirective>
                        <MarkerDirective visible={true} shape='Circle' height={15} width={15} fill='#b38600'
                            border={{
                                color: '#e6f2ff',
                                width: 2
                            }}
                            tooltipSettings={{
                                visible: true, valuePath: 'population', format: '<b>Name:</b> ${name} <br/> <b>State:</b> ${state} <br/> <b>Country:</b> ${country}',
                                textStyle: { fontFamily: 'inherit' }
                            }}
                            clusterSettings={{
                                allowClustering: true,
                                allowDeepClustering: false,
                                allowClusterExpand: true,
                                labelStyle: {
                                    color: 'white',
                                    size: '10px'
                                },
                                shape: 'Image',
                                height: 40, width: 40,
                                imageUrl: 'https://ej2.syncfusion.com/react/demos/src/maps/images/cluster-france.svg'
                            }}
                            animationDuration={0}
                            dataSource={[
                                { latitude: 48.8584, longitude: 2.2945, name: 'Eiffel Tower', state: 'Paris', country: 'France' },
                                { latitude: 48.8606, longitude: 2.3376, name: 'Louvre Museum', state: 'Paris', country: 'France' },
                                { latitude: 48.8529, longitude: 2.3500, name: 'Notre-Dame Cathedral', state: 'Paris', country: 'France' },
                                { latitude: 48.6360, longitude: 1.5115, name: 'Mont Saint-Michel', state: 'Normandy', country: 'France' }
                            ]}>
                        </MarkerDirective>
                        <MarkerDirective visible={true} shape='Circle' height={15} width={15} fill='#bf4040'
                            border={{
                                color: '#e6f2ff',
                                width: 2
                            }}
                            tooltipSettings={{
                                visible: true, valuePath: 'population', format: '<b>Name:</b> ${name} <br/> <b>State:</b> ${state} <br/> <b>Country:</b> ${country}',
                                textStyle: { fontFamily: 'inherit' }
                            }}
                            clusterSettings={{
                                allowClustering: true,
                                allowDeepClustering: false,
                                allowClusterExpand: true,
                                shape: 'Image',
                                height: 40, width: 40,
                                labelStyle: {
                                    color: 'white',
                                    size: '10px'
                                },
                                imageUrl: 'https://ej2.syncfusion.com/react/demos/src/maps/images/cluster-usa.svg'
                            }}
                            animationDuration={0}
                            dataSource={[
                                { latitude: 35.019028, longitude: -85.339439, name: 'Ruby Falls', state: 'Tennessee', country: 'United States of America' },
                                { latitude: 35.654613, longitude: -105.996979, name: 'Meow Wolf Santa Fe', state: 'New Mexico', country: 'United States of America' },
                                { latitude: 36.107216, longitude: -115.175804, name: 'City Center of Las Vegas', state: 'Nevada', country: 'United States of America' },
                                { latitude: 36.879047, longitude: -111.510498, name: 'Horseshoe Bend', state: 'Arizona', country: 'United States of America' },
                                { latitude: 36.011955, longitude: -113.810951, name: 'Grand Canyon West Skywalk', state: 'Arizona', country: 'United States of America' }
                            ]}>
                        </MarkerDirective>
                        <MarkerDirective visible={true} shape='Circle' height={15} width={15} fill='#00b3b3'
                            border={{
                                color: '#e6f2ff',
                                width: 2
                            }}
                            tooltipSettings={{
                                visible: true, valuePath: 'population', format: '<b>Name:</b> ${name} <br/> <b>State:</b> ${state} <br/> <b>Country:</b> ${country}',
                                textStyle: { fontFamily: 'inherit' }
                            }}
                            clusterSettings={{
                                allowClustering: true,
                                allowDeepClustering: false,
                                allowClusterExpand: true,
                                shape: 'Image',
                                height: 40, width: 40,
                                labelStyle: {
                                    color: 'white',
                                    size: '10px'
                                },
                                imageUrl: 'https://ej2.syncfusion.com/react/demos/src/maps/images/cluster-india.svg'
                            }}
                            animationDuration={0}
                            dataSource={[
                                { latitude: 26.985901, longitude: 75.850700, name: 'Amber Fort, Amer', state: 'Rajastan', country: 'India' },
                                { latitude: 22.957390, longitude: 77.625275, name: 'Bhimbetka, Raisen District', state: 'Madhya Pradesh', country: 'India' },
                                { latitude: 26.809330, longitude: 75.540527, name: 'Bagru Fort, Bagru', state: 'Rajasthan', country: 'India' },
                                { latitude: 25.489504, longitude: 80.330116, name: 'Kalinjar Fort, Banda', state: 'Uttar Pradesh', country: 'India' },
                                { latitude: 27.988890, longitude: 76.388336, name: 'Neemrana', state: 'Rajasthan', country: 'India' }
                            ]}>
                        </MarkerDirective>
                    </MarkersDirective>
                </LayerDirective>
            </LayersDirective>
        </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import { world_map } from 'world-map.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, MarkersDirective, MarkerDirective, Marker, Inject, MapsTooltip, Zoom } from '@syncfusion/ej2-react-maps';
export function App() {
    return (
        <MapsComponent id="maps"
            titleSettings={{ text: 'Attractive places around the world', textStyle: { size: '16px', fontFamily: 'inherit' } }}
            zoomSettings={{
                enable: true,
                toolbarSettings: {
                    buttonSettings: {
                        toolbarItems: ['Zoom', 'ZoomIn', 'ZoomOut', 'Pan', 'Reset']
                    }
                }
            }}>
            <Inject services={[Marker, MapsTooltip, Zoom]} />
            <LayersDirective>
                <LayerDirective shapeData={world_map} >
                    <MarkersDirective>
                        <MarkerDirective visible={true} shape='Circle' height={15} width={15} fill='#b38600'
                            border={{
                                color: '#e6f2ff',
                                width: 2
                            }}
                            tooltipSettings={{
                                visible: true, valuePath: 'population', format: '<b>Name:</b> ${name} <br/> <b>State:</b> ${state} <br/> <b>Country:</b> ${country}',
                                textStyle: { fontFamily: 'inherit' }
                            }}
                            clusterSettings={{
                                allowClustering: true,
                                allowDeepClustering: false,
                                allowClusterExpand: true,
                                labelStyle: {
                                    color: 'white',
                                    size: '10px'
                                },
                                shape: 'Image',
                                height: 40, width: 40,
                                imageUrl: 'https://ej2.syncfusion.com/react/demos/src/maps/images/cluster-france.svg'
                            }}
                            animationDuration={0}
                            dataSource={[
                                { latitude: 48.8584, longitude: 2.2945, name: 'Eiffel Tower', state: 'Paris', country: 'France' },
                                { latitude: 48.8606, longitude: 2.3376, name: 'Louvre Museum', state: 'Paris', country: 'France' },
                                { latitude: 48.8529, longitude: 2.3500, name: 'Notre-Dame Cathedral', state: 'Paris', country: 'France' },
                                { latitude: 48.6360, longitude: 1.5115, name: 'Mont Saint-Michel', state: 'Normandy', country: 'France' }
                            ]}>
                        </MarkerDirective>
                        <MarkerDirective visible={true} shape='Circle' height={15} width={15} fill='#bf4040'
                            border={{
                                color: '#e6f2ff',
                                width: 2
                            }}
                            tooltipSettings={{
                                visible: true, valuePath: 'population', format: '<b>Name:</b> ${name} <br/> <b>State:</b> ${state} <br/> <b>Country:</b> ${country}',
                                textStyle: { fontFamily: 'inherit' }
                            }}
                            clusterSettings={{
                                allowClustering: true,
                                allowDeepClustering: false,
                                allowClusterExpand: true,
                                shape: 'Image',
                                height: 40, width: 40,
                                labelStyle: {
                                    color: 'white',
                                    size: '10px'
                                },
                                imageUrl: 'https://ej2.syncfusion.com/react/demos/src/maps/images/cluster-usa.svg'
                            }}
                            animationDuration={0}
                            dataSource={[
                                { latitude: 35.019028, longitude: -85.339439, name: 'Ruby Falls', state: 'Tennessee', country: 'United States of America' },
                                { latitude: 35.654613, longitude: -105.996979, name: 'Meow Wolf Santa Fe', state: 'New Mexico', country: 'United States of America' },
                                { latitude: 36.107216, longitude: -115.175804, name: 'City Center of Las Vegas', state: 'Nevada', country: 'United States of America' },
                                { latitude: 36.879047, longitude: -111.510498, name: 'Horseshoe Bend', state: 'Arizona', country: 'United States of America' },
                                { latitude: 36.011955, longitude: -113.810951, name: 'Grand Canyon West Skywalk', state: 'Arizona', country: 'United States of America' }
                            ]}>
                        </MarkerDirective>
                        <MarkerDirective visible={true} shape='Circle' height={15} width={15} fill='#00b3b3'
                            border={{
                                color: '#e6f2ff',
                                width: 2
                            }}
                            tooltipSettings={{
                                visible: true, valuePath: 'population', format: '<b>Name:</b> ${name} <br/> <b>State:</b> ${state} <br/> <b>Country:</b> ${country}',
                                textStyle: { fontFamily: 'inherit' }
                            }}
                            clusterSettings={{
                                allowClustering: true,
                                allowDeepClustering: false,
                                allowClusterExpand: true,
                                shape: 'Image',
                                height: 40, width: 40,
                                labelStyle: {
                                    color: 'white',
                                    size: '10px'
                                },
                                imageUrl: 'https://ej2.syncfusion.com/react/demos/src/maps/images/cluster-india.svg'
                            }}
                            animationDuration={0}
                            dataSource={[
                                { latitude: 26.985901, longitude: 75.850700, name: 'Amber Fort, Amer', state: 'Rajastan', country: 'India' },
                                { latitude: 22.957390, longitude: 77.625275, name: 'Bhimbetka, Raisen District', state: 'Madhya Pradesh', country: 'India' },
                                { latitude: 26.809330, longitude: 75.540527, name: 'Bagru Fort, Bagru', state: 'Rajasthan', country: 'India' },
                                { latitude: 25.489504, longitude: 80.330116, name: 'Kalinjar Fort, Banda', state: 'Uttar Pradesh', country: 'India' },
                                { latitude: 27.988890, longitude: 76.388336, name: 'Neemrana', state: 'Rajasthan', country: 'India' }
                            ]}>
                        </MarkerDirective>
                    </MarkersDirective>
                </LayerDirective>
            </LayersDirective>
        </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Tooltip for markers

Tooltips are used to display additional information about a marker on mouse hover or touch end events. This can be enabled for markers by setting the visible property of tooltipSettings to true. The valuePath property in the tooltipSettings specifies the field name from the dataSource whose value will be displayed as the tooltip text.

import { usa_map } from 'usa.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, MarkersDirective, MarkerDirective, MapsTooltip, Marker, Inject } from '@syncfusion/ej2-react-maps';
export function App() {
   return(
                <MapsComponent >
                <Inject services={[Marker, MapsTooltip]} />
                    <LayersDirective>
                        <LayerDirective shapeData={usa_map}>
                        <MarkersDirective>
                            <MarkerDirective visible={true}
                                            height={20}
                                            width={20}
                                            animationDuration={0}
                                            tooltipSettings={{
                                                visible: true,
                                                valuePath:'city'
                                            }}
                                            dataSource={[
                                                { latitude: 40.7424509, longitude: -74.0081468, city: 'New York' }
                                            ]}>
                            </MarkerDirective>
                        </MarkersDirective>
                        </LayerDirective>
                    </LayersDirective>
                </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);
import { usa_map } from 'usa.ts';
import * as React from "react";
import * as ReactDOM from "react-dom";
import { MapsComponent, LayersDirective, LayerDirective, MarkersDirective, MarkerDirective, MapsTooltip, Marker, Inject } from '@syncfusion/ej2-react-maps';
export function App() {
   return(
                <MapsComponent >
                <Inject services={[Marker, MapsTooltip]} />
                    <LayersDirective>
                        <LayerDirective shapeData={usa_map}>
                        <MarkersDirective>
                            <MarkerDirective visible={true}
                                            height={20}
                                            width={20}
                                            animationDuration={0}
                                            tooltipSettings={{
                                                visible: true,
                                                valuePath:'city'
                                            }}
                                            dataSource={[
                                                { latitude: 40.7424509, longitude: -74.0081468, city: 'New York' }
                                            ]}>
                            </MarkerDirective>
                        </MarkersDirective>
                        </LayerDirective>
                    </LayersDirective>
                </MapsComponent>
    );
}
const root = ReactDOM.createRoot(document.getElementById('container'));
root.render(<App />);

Markers in Vue Maps component

6 Feb 202624 minutes to read

Markers are visual indicators used to pinpoint specific locations on the Maps. They can display desired symbols to highlight points of interest or important geographic positions. Markers can be enabled by setting thevisible property of the markerSettings to true.

Adding marker

To add the markers, the dataSource property of the markerSettings has a list of objects that contains the data for markers. Using this property, any number of markers can be added to the layers of the Maps. By default, it displays the markers based on the specified latitude and longitude in the given data source. Each data source object contains the following list of properties.

  • latitude - The latitude value that determines the vertical (Y) position of the marker.
  • longitude - The longitude value that determines the horizontal (X) position of the marker.
<template>
    <div id="app">
          <div class='wrapper'>
            <ejs-maps >
                <e-layers>
                    <e-layer :shapeData='shapeData' :markerSettings='markerSettings'></e-layer>
                </e-layers>
            </ejs-maps>
        </div>
    </div>
</template>

<script>

import { MapsComponent, Marker, LayerDirective, LayersDirective } from '@syncfusion/ej2-vue-maps';
import { world_map } from './world-map.js';

export default {
name: "App",
components: {
"ejs-maps":MapsComponent,
"e-layers":LayersDirective,
"e-layer":LayerDirective
},
data () {
    return {
      shapeData: world_map,
        markerSettings: [
            {
                dataSource: [
                    { latitude: 49.95121990866204, longitude: 18.468749999999998 },
                    { latitude: 59.88893689676585, longitude: -109.3359375 },
                    { latitude: -6.64607562172573, longitude: -55.54687499999999 }
                ],
                visible: true,
                height: 20,
                width: 20,
                animationDuration: 0
            }
        ]
    }
},
provide: {
    maps: [Marker]
}
}
</script>
<style>
  .wrapper {
    max-width: 400px;
    margin: 0 auto;
  }
</style>

Adding marker template

The Marker can be added as a template in the Maps component. The template property of the markerSettings is used to set the HTML string or id of an element as a template.

<template>
    <div id="app">
          <div class='wrapper'>
            <ejs-maps >
                <e-layers>
                    <e-layer :shapeData='shapeData' >
                        <e-markerSettings>
                            <e-markerSetting visible= true :template='contentTemplate' :dataSource ="dataSource" animationDuration = 0 ></e-markerSetting>
                            <e-markerSetting visible= true :template='contentTemplate1' :dataSource ="dataSource1" animationDuration = 0 ></e-markerSetting>
                            <e-markerSetting visible= true :template='contentTemplate2' :dataSource ="dataSource2" animationDuration = 0 ></e-markerSetting>
                        </e-markerSettings>
                    </e-layer>
                </e-layers>
            </ejs-maps>
        </div>
    </div>
</template>

<script>

import { MapsComponent, Marker, LayerDirective, LayersDirective, MarkerSettingDirective, MarkerSettingsDirective } from '@syncfusion/ej2-vue-maps';
import { world_map } from './world-map.js';
import {createApp} from 'vue';

const app = createApp({});
 
const cTemplate = app.component('MapsComponent', {
    template: '<div id="marker4" style="color:red" class="markerTemplate">Europe</div>',
    data() { return {  }; }
});

const cTemplate1 = app.component('MapsComponent1', {
    template: '<div id="marker5" class="markerTemplate" style="width:50px;color:blue">NorthAmerica</div>',
    data() { return {  }; }
});

const cTemplate2 = app.component('MapsComponent2', {
    template: '<div id="marker6" class="markerTemplate" style="width:50px;color:green">South America </div>',
    data() { return {  }; }
});

export default {
name: "App",
components: {
"ejs-maps":MapsComponent,
"e-layers":LayersDirective,
"e-layer":LayerDirective,
"e-markerSettings":MarkerSettingsDirective,
"e-markerSetting":MarkerSettingDirective
},
data () {
    return{
        shapeData: world_map,
        dataSource: [
          { latitude: 49.95121990866204, longitude: 18.468749999999998 }
       ],
      dataSource1: [
          { latitude: 59.88893689676585, longitude: -109.3359375 }
      ],
       dataSource2: [
         { latitude: -6.64607562172573, longitude: -55.54687499999999 }
       ],
       contentTemplate: function () {
          return {
          template: cTemplate
        }
      },
      contentTemplate1: function () {
          return {
          template: cTemplate1
        }
      },
      contentTemplate2: function () {
          return {
          template: cTemplate2
        }
      },
    }
},
provide: {
    maps: [ Marker]
}
}
</script>
<style>
  .wrapper {
    max-width: 400px;
    margin: 0 auto;
  }
</style>

Customization

The following properties are available in markerSettings to customize the Markers of the Maps component.

  • border - To customize the color, width and opacity of the border for the markers in Maps.
  • fill - To apply the color for markers in Maps.
  • dashArray - To define the pattern of dashes and gaps that is applied to the outline of the markers in Maps.
  • height - To customize the height of the markers in Maps.
  • width - To customize the width of the markers in Maps.
  • offset - To customize the position of the markers in Maps.
  • opacity - To customize the transparency of the markers in Maps.
  • animationDelay - To change the time delay in the transition for markers.
  • animationDuration - To change the time duration of animation for markers.
<template>
    <div id="app">
          <div class='wrapper'>
            <ejs-maps >
                <e-layers>
                    <e-layer :shapeData='shapeData' :markerSettings='markerSettings'></e-layer>
                </e-layers>
            </ejs-maps>
        </div>
    </div>
</template>

<script>

import { MapsComponent, Marker, LayerDirective, LayersDirective } from '@syncfusion/ej2-vue-maps';
import { world_map } from './world-map.js';

export default {
name: "App",
components: {
"ejs-maps":MapsComponent,
"e-layers":LayersDirective,
"e-layer":LayerDirective
},
data () {
    return{
      shapeData: world_map,
        markerSettings: [{
            visible: true,
            border: {
                color: 'green',
                width: 2
            },
            fill: 'red',
            dashArray: '1',
            height: 20,
            width: 20,
            opacity: 0.9,
            animationDelay: 100,
            animationDuration: 1000,
            shape: 'Balloon',
            dataSource: [
                { latitude: 37.0000, longitude: -120.0000, city: 'California' },
                { latitude: 40.7127, longitude: -74.0059, city: 'New York' },
                { latitude: 42, longitude: -93, city: 'Iowa' }
            ]
        }]
    }
},
provide: {
    maps: [Marker]
}
}
</script>
<style>
  .wrapper {
    max-width: 400px;
    margin: 0 auto;
  }
</style>

Marker shapes

The Maps component supports the following marker shapes. To set the shape of the marker, the shape property in markerSettings is used.

  • Balloon
  • Circle
  • Cross
  • Diamond
  • Image
  • Rectangle
  • Star
  • Triangle
  • VerticalLine
  • HorizontalLine

Rendering marker shape as image

To render a marker as an image in Maps, set the shape property of markerSettings as Image and specify the path of the image to imageUrl property. There is another way to render a marker as an image using the imageUrlValuePath property of the markerSettings. Bind the field name that contains the path of the image in the data source to the imageUrlValuePath property.

<template>
    <div id="app">
          <div class='wrapper'>
            <ejs-maps >
                <e-layers>
                    <e-layer :shapeData='shapeData' :markerSettings='markerSettings'></e-layer>
                </e-layers>
            </ejs-maps>
        </div>
    </div>
</template>

<script>

import { MapsComponent, Marker, LayerDirective, LayersDirective } from '@syncfusion/ej2-vue-maps';
import { world_map } from './world-map.js';

export default {
name: "App",
components: {
"ejs-maps":MapsComponent,
"e-layers":LayersDirective,
"e-layer":LayerDirective
},
data () {
    return {
      shapeData: world_map,
      markerSettings: [{
          visible: true,
          shape: 'Image',
          imageUrl: 'https://ej2.syncfusion.com/vue/demos/src/maps/images/ballon.png',
          height: 20,
          width: 20,
          dataSource: [
              { latitude: 37.0000, longitude: -120.0000, city: 'California' },
              { latitude: 40.7127, longitude: -74.0059, city: 'New York' },
              { latitude: 42, longitude: -93, city: 'Iowa' }
          ]
      }]
    }
},
provide: {
    maps: [Marker]
}
}
</script>
<style>
  .wrapper {
    max-width: 400px;
    margin: 0 auto;
  }
</style>

Multiple marker groups

Multiple groups of markers can be added to the Maps by providing an array of marker configurations to the markerSettings property. Each marker group can have its own customization options defined within the markerSettings.

<template>
    <div id="app">
          <div class='wrapper'>
            <ejs-maps >
                <e-layers>
                    <e-layer :shapeData='shapeData' :markerSettings='markerSettings'></e-layer>
                </e-layers>
            </ejs-maps>
        </div>
    </div>
</template>

<script>

import { MapsComponent, Marker, LayerDirective, LayersDirective } from '@syncfusion/ej2-vue-maps';
import { world_map } from './world-map.js';

export default {
name: "App",
components: {
"ejs-maps":MapsComponent,
"e-layers":LayersDirective,
"e-layer":LayerDirective,
},
data () {
    return {
      shapeData: world_map,
      markerSettings: [{
          visible: true,
          shape: 'Diamond',
          height: 15,
          fill: "green",
          width: 15,
          dataSource: [
              { latitude: 37.0000, longitude: -120.0000, name:'California'},
              { latitude: 40.7127, longitude: -74.0059, name:"New York" },
              { latitude: 42, longitude: -93, name:'Iowa' }
          ]
        },
        {
            visible: true,
            dataSource: [
              { latitude: 19.228825, longitude: 72.854118, name: "Mumbai"},
              { latitude: 28.610001, longitude: 77.230003, name: "Delhi" },
              { latitude: 13.067439, longitude: 80.237617, name: "Chennai"}
            ],
            shape: 'Circle',
            fill: "blue",
            height: 10,
            width: 10
        }]
    }
},
provide: {
    maps: [Marker]
}
}
</script>
<style>
  .wrapper {
    max-width: 400px;
    margin: 0 auto;
  }
</style>

Customize marker shapes from data source

Bind different colors and shapes to the marker from data source

Using the shapeValuePath and colorValuePath properties, apply the color and shape of the marker can be applied from the given data source. Bind the data source to the dataSource property of the markerSettings and set the field names that contains the shape and color values in the data source to the shapeValuePath and colorValuePath properties.

<template>
    <div id="app">
          <div class='wrapper'>
            <ejs-maps >
                <e-layers>
                    <e-layer :shapeData='shapeData' :markerSettings='markerSettings'></e-layer>
                </e-layers>
            </ejs-maps>
        </div>
    </div>
</template>

<script>

import { MapsComponent, Marker, LayerDirective, LayersDirective } from '@syncfusion/ej2-vue-maps';
import { world_map } from './world-map.js';

export default {
name: "App",
components: {
"ejs-maps":MapsComponent,
"e-layers":LayersDirective,
"e-layer":LayerDirective
},
data () {
    return{
      shapeData: world_map,
        markerSettings: [
            {
                dataSource: [
                  { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe', color:'red', shape:'Triangle' },
                  { latitude: 59.88893689676585, longitude: -109.3359375, name:'North America',
                  color:'blue', shape:'Pentagon' },
                  { latitude: -6.64607562172573, longitude: -55.54687499999999, name:'South America',
                color:'green', shape:'InvertedTriangle' }
                ],
                visible: true,
                shapeValuePath:'shape',
                colorValuePath:'color',
            },
        ]
    }
},
provide: {
    maps: [Marker]
}
}
</script>
<style>
  .wrapper {
    max-width: 400px;
    margin: 0 auto;
  }
</style>

Setting value path from the data source

The latitude and longitude values are used to determine the location of each marker in the Maps. The latitudeValuePath and longitudeValuePath properties are used to specify the value path that presents in the data source of the marker. In the following example, the field name from the data source is set to the latitudeValuePath and longitudeValuePath properties.

<template>
    <div id="app">
          <div class='wrapper'>
            <ejs-maps >
                <e-layers>
                    <e-layer :shapeData='shapeData' :markerSettings='markerSettings'></e-layer>
                </e-layers>
            </ejs-maps>
        </div>
    </div>
</template>

<script>

import { MapsComponent, Marker, LayerDirective, LayersDirective } from '@syncfusion/ej2-vue-maps';
import { world_map } from './world-map.js';

export default {
name: "App",
components: {
"ejs-maps":MapsComponent,
"e-layers":LayersDirective,
"e-layer":LayerDirective
},
data () {
    return{
      shapeData: world_map,
        markerSettings: [{
            visible: true,
            latitudeValuePath: 'latitude',
            longitudeValuePath: 'longitude',
            dataSource: [
                { latitude: 49.95121990866204, longitude: 18.468749999999998 },
                { latitude: 59.88893689676585, longitude: -109.3359375},
                { latitude: -6.64607562172573, longitude: -55.54687499999999 }
            ]
         }]
    }
},
provide: {
    maps: [Marker]
}
}
</script>
<style>
  .wrapper {
    max-width: 400px;
    margin: 0 auto;
  }
</style>

Setting different sizes for markers individually

The size of the markers in a marker group can be customized using the widthValuePath and heightValuePath properties, which allow the user to change the width and height of the markers based on values from the given data source. Bind the data source to the dataSource property of the markerSettings, and specify the field names containing the width and height values in the data source for the widthValuePath and heightValuePath properties.

<template>
    <div id="app">
          <div class='wrapper'>
            <ejs-maps >
                <e-layers>
                    <e-layer :shapeData='shapeData' :markerSettings='markerSettings'></e-layer>
                </e-layers>
            </ejs-maps>
        </div>
    </div>
</template>

<script>

import { MapsComponent, Marker, LayerDirective, LayersDirective } from '@syncfusion/ej2-vue-maps';
import { world_map } from './world-map.js';

export default {
name: "App",
components: {
"ejs-maps":MapsComponent,
"e-layers":LayersDirective,
"e-layer":LayerDirective
},
data () {
    return{
      shapeData: world_map,
        markerSettings: [{
            visible: true,
            shape: 'Circle',
            widthValuePath: 'width',
            heightValuePath: 'height',
            dataSource: [
                { latitude: 49.95121990866204, longitude: 18.468749999999998, width: 30, height: 30 },
                { latitude: 59.88893689676585, longitude: -109.3359375, width: 20, height: 20},
                { latitude: -6.64607562172573, longitude: -55.54687499999999, width: 10, height: 10}
            ]
         }]
    }
},
provide: {
    maps: [Marker]
}
}
</script>
<style>
  .wrapper {
    max-width: 400px;
    margin: 0 auto;
  }
</style>

Repositioning the marker using drag and drop

The markers on the map can be dragged and dropped to change their position. To enable marker drag and drop, set the enableDrag property to true in the markerSettings property.

<template>
    <div id="app">
          <div>
            <ejs-maps >
                <e-layers>
                    <e-layer :shapeData='shapeData' :shapeSettings='shapeSettings' :markerSettings='markerSettings'></e-layer>
                </e-layers>
            </ejs-maps>
        </div>
    </div>
</template>

<script>

import { MapsComponent, Marker, MapsTooltip, LayerDirective, LayersDirective } from '@syncfusion/ej2-vue-maps';
import { world_map } from './world-map.js';

export default {
name: "App",
components: {
"ejs-maps":MapsComponent,
"e-layers":LayersDirective,
"e-layer":LayerDirective
},
data () {
    return{
        shapeData: world_map,
        shapeSettings:{
          fill:'#C3E6ED'
        },
        markerSettings: [{
            visible: true,
            enableDrag:true,
            animationDuration: 0,
            shape: 'Balloon',
            width: 20,
            height: 20,
            border: { width: 2, color: '#285255' },
            tooltipSettings: {
                visible: true,
                valuePath: 'name',
            },
            dataSource: [
                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'MarkerOne' },
                { latitude: 59.88893689676585, longitude: -109.3359375, name:'MarkerTwo'},
                { latitude: -6.64607562172573, longitude: -55.54687499999999 , name:'MarkerThree'},
                { latitude: 23.644385824912135, longitude: 77.83189239539234  , name:'MarkerFour'},
                { latitude: 63.66569332894224, longitude: 98.2225173953924 , name:'MarkerFive'}
            ]
        }]
    }
},
provide: {
    maps: [Marker, MapsTooltip]
}
}
</script>

The data of the drag and dropped marker in the marker data source can be customized using the markerDragStart and markerDragEnd events. When you change the appropriate marker data, the tooltip and legend item text of that marker are automatically updated. The following properties are available in the event argument of the marker drag events.

Argument Name Description
dataIndex It represents the index of the data of the dragged marker in the marker data source.
latitude It represents the latitude coordinate point of the dragged marker.
longitude It represents the longitude coordinate point for the dragged marker.
markerIndex It represents the index of the marker setting.
layerIndex It represents the index of the layer in which the marker belongs.
name It represents the name of the event.
x It represents the horizontal location of the mouse pointer on the map when the drag action is performed.
y It represents the vertical location of the mouse pointer on the map when the drag action is performed.

The following example shows how to use marker drag events to customize the data of the drag and dropped marker in the marker data source.

<template>
    <div id="app">
          <div>
            <ejs-maps ref="maps" :legendSettings='legendSettings' :markerDragStart='markerDragStart' :markerDragEnd='markerDragEnd'>
                <e-layers>
                    <e-layer :shapeData='shapeData' :shapeSettings='shapeSettings' :markerSettings='markerSettings'></e-layer>
                </e-layers>
            </ejs-maps>
        </div>
    </div>
</template>

<script>

import { MapsComponent, Marker, Legend, MapsTooltip, LayerDirective, LayersDirective } from '@syncfusion/ej2-vue-maps';
import { world_map } from './world-map.js';

export default {
name: "App",
components: {
"ejs-maps":MapsComponent,
"e-layers":LayersDirective,
"e-layer":LayerDirective
},
data () {
    return{
        shapeData: world_map,
        shapeSettings:{
          fill:'#C3E6ED'
        },
        legendSettings:{
            visible:true,
            type:'Markers',
            shape:'Circle',
            shapeWidth:10,
            shapeHeight:10,
            fill:'#FF471A',
            shapeBorder: { width: 2, color: '#285255' },
        },
        markerSettings: [{
            visible: true,
            enableDrag:true,
            legendText:'name',
            animationDuration: 0,
            shape: 'Balloon',
            width: 20,
            height: 20,
            border: { width: 2, color: '#285255' },
            tooltipSettings: {
                visible: true,
                valuePath: 'name',
            },
            dataSource: [
                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'MarkerOne' },
                { latitude: 59.88893689676585, longitude: -109.3359375, name:'MarkerTwo'},
                { latitude: -6.64607562172573, longitude: -55.54687499999999 , name:'MarkerThree'},
                { latitude: 23.644385824912135, longitude: 77.83189239539234  , name:'MarkerFour'},
                { latitude: 63.66569332894224, longitude: 98.2225173953924 , name:'MarkerFive'}
            ]
        }]
    }
},
provide: {
    maps: [Marker, Legend, MapsTooltip]
},
methods:{
    markerDragStart: function() {
       // When the marker begins to move on the map, the event is triggered.
    },
    markerDragEnd: function(args) {
        // When the marker on the map stops dragging, the event is triggered.
        let mapsInstance = this.$refs.maps.ej2Instances;
        mapsInstance.layers[args.layerIndex].markerSettings[args.markerIndex].dataSource[args.dataIndex].name = 'Dragged Marker ' + (args.dataIndex + 1);
        mapsInstance.refresh();
    }  
}
}
</script>

Marker zooming

The Maps can be initially scaled to fit all markers within the visible area. This can be achieved by setting the shouldZoomInitially property in zoomSettings to true.

<template>
    <div id="app">
          <div class='wrapper'>
            <ejs-maps :zoomSettings='zoomSettings' >
                <e-layers>
                    <e-layer :shapeData='shapeData'  :markerSettings='markerSettings'></e-layer>
                </e-layers>
            </ejs-maps>
        </div>
    </div>
</template>

<script>

import { MapsComponent, Marker, Zoom, LayerDirective, LayersDirective } from '@syncfusion/ej2-vue-maps';
import { world_map } from './world-map.js';

export default {
name: "App",
components: {
"ejs-maps":MapsComponent,
"e-layers":LayersDirective,
"e-layer":LayerDirective
},
data () {
    return{
        zoomSettings: {
          enable: true,
          toolbarSettings:{
              horizontalAlignment:'Near'
          },
          shouldZoomInitially: true
        },
        shapeData: world_map,
        markerSettings: [
            {
                dataSource:  [
                  { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                  { latitude: 59.88893689676585, longitude: -109.3359375, name:'North America' },
                  { latitude: -6.64607562172573, longitude: -55.54687499999999, name:'South America'}
                ],
                visible: true
            },
        ]
    }
},
provide: {
    maps: [Marker, Zoom]
}
}
</script>

Marker Clustering

The Maps component provides support to cluster markers when they overlap each other. The number displayed on a cluster indicates how many overlapping markers it contains. When zooming in on a cluster location, the cluster count decreases as individual markers become visible. When zooming out, overlapping markers are grouped again, increasing the cluster count.

To enable clustering for markers, set the allowClustering property of markerClusterSettings in the layers to true. Customization of clustering can be done using the markerClusterSettings property.

<template>
    <div id="app">
          <div class='wrapper'>
            <ejs-maps  :titleSettings='titleSettings' :zoomSettings='zoomSettings'  :useGroupingSeparator='useGroupingSeparator' format='n'>
                <e-layers>
                    <e-layer :shapeData='shapeData' :shapeSettings='shapeSettings' :markerClusterSettings='markerClusterSettings' :markerSettings='markerSettings'></e-layer>
                </e-layers>
            </ejs-maps>
        </div>
    </div>
</template>

<script>

import { MapsComponent, Marker, Zoom, MapsTooltip, LayerDirective, LayersDirective } from '@syncfusion/ej2-vue-maps';
import { world_map } from './world-map.js';
import { cluster } from './marker-cluster.js';

export default {
name: "App",
components: {
"ejs-maps":MapsComponent,
"e-layers":LayersDirective,
"e-layer":LayerDirective
},
data () {
    return{
        useGroupingSeparator: true,
        zoomSettings: {
            enable: true,
        },
        shapeData: world_map,
        shapeSettings: {
            fill: '#C1DFF5'
        },
        titleSettings: {
            text: 'Top 13 largest cities in the World',
            textStyle: {
                size: '16px'
            }
        },
        markerClusterSettings: {
             allowClustering: true,
             shape: 'Circle',
             height: 40,
             width: 40,
             labelStyle : { color: 'white'},
        },
        markerSettings: [
            {
                dataSource: cluster,
                visible: true,
                shape: 'Balloon',
                height:20,
                width:20,
                animationDuration:0,
                tooltipSettings: {
                    visible: true,
                    valuePath: 'area',
                }
            },
        ]
    }
},
provide: {
    maps: [Marker, Zoom, MapsTooltip]
}
}
</script>
<style>
  .wrapper {
    max-width: 400px;
    margin: 0 auto;
  }
</style>

Customization of marker cluster

The following properties are available to customize the marker clustering in the Maps component.

  • border - To customize the color, width and opacity of the border of cluster in Maps.
  • connectorLineSettings - To customize the connector line in cluster separating the markers.
  • dashArray - To customize the dash array for the marker cluster in Maps.
  • fill - Applies the color of the cluster in Maps.
  • height - To customize the height of the marker cluster in Maps.
  • imageUrl - To customize the URL path for the marker cluster when the cluster shape is set as image in Maps.
  • labelStyle - To customize the text in marker cluster.
  • offset - To customize the offset position for the marker cluster in Maps.
  • opacity - To customize the opacity of the marker cluster.
  • shape - To customize the shape for the cluster of markers.
  • width - To customize the width of the marker cluster in Maps.
<template>
    <div id="app">
          <div class='wrapper'>
            <ejs-maps  :titleSettings='titleSettings' :zoomSettings='zoomSettings'  :useGroupingSeparator='useGroupingSeparator' format='n'>
                <e-layers>
                    <e-layer :shapeData='shapeData' :shapeSettings='shapeSettings' :markerClusterSettings='markerClusterSettings' :markerSettings='markerSettings'></e-layer>
                </e-layers>
            </ejs-maps>
        </div>
    </div>
</template>

<script>

import { MapsComponent, Marker, Zoom, MapsTooltip, Point, LayerDirective, LayersDirective } from '@syncfusion/ej2-vue-maps';
import { world_map } from './world-map.js';
import { cluster } from './marker-cluster.js';

export default {
name: "App",
components: {
"ejs-maps":MapsComponent,
"e-layers":LayersDirective,
"e-layer":LayerDirective
},
data () {
    return{
        useGroupingSeparator: true,
        zoomSettings: {
            enable: true,
        },
        shapeData: world_map,
        shapeSettings: {
            fill: '#C1DFF5'
        },
        titleSettings: {
            text: 'Top 13 largest cities in the World',
            textStyle: {
                size: '16px'
            }
        },
        markerClusterSettings: {
            allowClustering: true,
            allowClusterExpand: true,
            shape: 'Circle',
            height: 40,
            width: 40,
            labelStyle : { color: 'white'},
            offset: new Point(10, 20),
            opacity: 0.9,
            fill: 'green',
            connectorLineSettings: {
                color: 'orange',
                opacity: 0.8,
                width: 2
            }
        },
        markerSettings: [
            {
                dataSource: cluster,
                visible: true,
                shape: 'Balloon',
                height:20,
                width:20,
                animationDuration:0,
                tooltipSettings: {
                    visible: true,
                    valuePath: 'area',
                }
            },
        ]
    }
},
provide: {
    maps: [Marker, Zoom, MapsTooltip]
}
}
</script>
<style>
  .wrapper {
    max-width: 400px;
    margin: 0 auto;
  }
</style>

Expanding the marker cluster

The cluster is formed by grouping an identical and non-identical marker from the surrounding area. By clicking on the cluster and setting the allowClusterExpand property in markerClusterSettings as true to expand the identical markers. If zooming is performed in any of the locations of the cluster, the number on the cluster will decrease and the overlapping marker will be split into an individual marker on the map. When performing zoom out, it will increase the marker count and then cluster it again.

<template>
    <div id="app">
          <div class='wrapper'>
            <ejs-maps  :zoomSettings='zoomSettings' >
                <e-layers>
                    <e-layer :shapeData='shapeData' :markerClusterSettings='markerClusterSettings' :markerSettings='markerSettings'></e-layer>
                </e-layers>
            </ejs-maps>
        </div>
    </div>
</template>

<script>

import { MapsComponent, Marker, Zoom, LayerDirective, LayersDirective } from '@syncfusion/ej2-vue-maps';
import { world_map } from './world-map.js';

export default {
name: "App",
components: {
"ejs-maps":MapsComponent,
"e-layers":LayersDirective,
"e-layer":LayerDirective
},
data () {
    return{
        zoomSettings: {
            enable: true,
            mouseWheelZoom : true,
        },
        shapeData: world_map,
        markerClusterSettings: {
            allowClustering: true,
            allowClusterExpand: true,
            shape: 'Circle',
            height: 40,
            width: 40,
            labelStyle : { color: 'white'},
        },
        markerSettings: [
            {
                dataSource:[
                  { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                  { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                  { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                  { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                  { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                  { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                  { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                  { latitude: 59.88893689676585, longitude: -109.3359375, name:'North America' },
                  { latitude: -6.64607562172573, longitude: -55.54687499999999, name:'South America'}
                ] ,
                visible: true
            },
        ]
    }
},
provide: {
    maps: [Marker, Zoom ]
}
}
</script>
<style>
  .wrapper {
    max-width: 400px;
    margin: 0 auto;
  }
</style>

Clustering markers within each marker group

Marker clustering can be enabled for each marker group in the map by using the clusterSettings property within the markerSettings property in the layers. This allows for individual customization of clusters for each marker group which group markers that are located near each other to reduce clutter and improve readability. When the allowClustering property is set to true, the markers within each group are clustered and visually represented as separate clusters. As users zoom in, the clusters expand to reveal individual markers, enabling more detailed exploration. Clusters can also be expanded manually by setting the allowClusterExpand property to true. The appearance of the clusters and their expansion behavior can be customized using the clusterSettings property, similar to the markerClusterSettings property, as explained in the sections above.

When the clusterSettings property is enabled for an individual marker group, the markerClusterSettings property within the layers becomes ineffective.

<template>
    <div id="app">
          <div class='wrapper'>
            <ejs-maps id='container' :titleSettings='titleSettings' :zoomSettings='zoomSettings'>
               <e-layers>
                   <e-layer :shapeData='shapeData' :markerSettings='marker'>
                    </e-layer>
                </e-layers>
            </ejs-maps>
        </div>
    </div>
</template>

<script>

import { MapsComponent, Marker, Zoom, MapsTooltip, LayerDirective, LayersDirective } from '@syncfusion/ej2-vue-maps';
import { world_map } from './world-map.js';

export default {
name: "App",
components: {
"ejs-maps":MapsComponent,
"e-layers":LayersDirective,
"e-layer":LayerDirective
},
data () {
    return{
        shapeData: world_map,
        titleSettings: {
            text: 'Attractive places around the world',
            textStyle: {
                size: '16px'
            }
        },
    marker: [{
        clusterSettings: {
            allowClustering: true,
            allowDeepClustering: false,
            allowClusterExpand: true,
            labelStyle: {
                color: 'white',
                size: '10px'
            },
            shape: 'Image',
            height: 40, width: 40,
            imageUrl: 'https://ej2.syncfusion.com/vue/demos/src/maps/images/cluster-france.svg'
        },
        visible: true,
        dataSource: [
            { latitude: 48.8584, longitude: 2.2945, name: 'Eiffel Tower', state: 'Paris', country: 'France' },
            { latitude: 48.8606, longitude: 2.3376, name: 'Louvre Museum', state: 'Paris', country: 'France' },
            { latitude: 48.8529, longitude: 2.3500, name: 'Notre-Dame Cathedral', state: 'Paris', country: 'France' },
            { latitude: 48.6360, longitude: 1.5115, name: 'Mont Saint-Michel', state: 'Normandy', country: 'France' }
        ],
        shape: 'Circle',
        height: 15,
        width: 15,
        fill: '#b38600',
        border: {
            color: '#e6f2ff',
            width: 2
        },
        tooltipSettings: {
            visible: true,
            valuePath: 'name',
            format: '<b>Name:</b> ${name} <br/> <b>State:</b> ${state} <br/> <b>Country:</b> ${country}'
        },
        animationDuration: 0
    },
    {
        clusterSettings: {
            allowClustering: true,
            allowDeepClustering: false,
            allowClusterExpand: true,
            shape: 'Image',
            height: 40, width: 40,
            labelStyle: {
                color: 'white',
                size: '10px'
            },
            imageUrl: 'https://ej2.syncfusion.com/vue/demos/src/maps/images/cluster-usa.svg'
        },
        visible: true,
        shape: 'Circle',
        height: 15,
        width: 15,
        fill: '#bf4040',
        border: {
            color: '#e6f2ff',
            width: 2
        },
        dataSource: [
            { latitude: 35.019028, longitude: -85.339439, name: 'Ruby Falls', state: 'Tennessee', country: 'United States of America' },
            { latitude: 35.654613, longitude: -105.996979, name: 'Meow Wolf Santa Fe', state: 'New Mexico', country: 'United States of America' },
            { latitude: 36.107216, longitude: -115.175804, name: 'City Center of Las Vegas', state: 'Nevada', country: 'United States of America' },
            { latitude: 36.879047, longitude: -111.510498, name: 'Horseshoe Bend', state: 'Arizona', country: 'United States of America' },
            { latitude: 36.011955, longitude: -113.810951, name: 'Grand Canyon West Skywalk', state: 'Arizona', country: 'United States of America' }
        ],
        tooltipSettings: {
            visible: true,
            valuePath: 'name',
            format: '<b>Name:</b> ${name} <br/> <b>State:</b> ${state} <br/> <b>Country:</b> ${country}'
        },
        animationDuration: 0
    },
    {
        clusterSettings: {
            allowDeepClustering: false,
            allowClusterExpand: true,
            allowClustering: true,
            shape: 'Image',
            height: 40, width: 40,
            labelStyle: {
                size: '10px',
                color: 'white'
            },
            imageUrl: 'https://ej2.syncfusion.com/vue/demos/src/maps/images/cluster-india.svg'
        },
        dataSource: [
            { latitude: 26.985901, longitude: 75.850700, name: 'Amber Fort, Amer', state: 'Rajastan', country: 'India' },
            { latitude: 22.957390, longitude: 77.625275, name: 'Bhimbetka, Raisen District', state: 'Madhya Pradesh', country: 'India' },
            { latitude: 26.809330, longitude: 75.540527, name: 'Bagru Fort, Bagru', state: 'Rajasthan', country: 'India' },
            { latitude: 25.489504, longitude: 80.330116, name: 'Kalinjar Fort, Banda', state: 'Uttar Pradesh', country: 'India' },
            { latitude: 27.988890, longitude: 76.388336, name: 'Neemrana', state: 'Rajasthan', country: 'India' }
        ],
        visible: true,
        shape: 'Circle',
        fill: '#00b3b3',
        border: {
            color: '#e6f2ff',
            width: 2
        },
        height: 15,
        width: 15,
        tooltipSettings: {
            visible: true,
            format: '<b>Name:</b> ${name} <br/> <b>State:</b> ${state} <br/> <b>Country:</b> ${country}',
            valuePath: 'name'
        },
        animationDuration: 0
    }],
        zoomSettings: {
            enable: true,
            toolbarSettings: {
                buttonSettings: {
                    toolbarItems: ['Zoom', 'ZoomIn', 'ZoomOut', 'Pan', 'Reset']
                }
            }
        },
        animationDuration: 0,   
    }
},
provide: {
    maps: [Marker, Zoom, MapsTooltip ]
}
}
</script>
<style>
  .wrapper {
    max-width: 400px;
    margin: 0 auto;
  }
</style>

Tooltip for markers

Tooltips are used to display additional information about a marker on mouse hover or touch end events. This can be enabled for markers by setting the visible property of tooltipSettings to true. The valuePath property in the tooltipSettings specifies the field name from the data source whose value will be displayed as the tooltip text.

<template>
    <div id="app">
          <div class='wrapper'>
            <ejs-maps >
                <e-layers>
                    <e-layer :shapeData='shapeData' :markerSettings='markerSettings'></e-layer>
                </e-layers>
            </ejs-maps>
        </div>
    </div>
</template>

<script>

import { MapsComponent, Marker, MapsTooltip, LayerDirective, LayersDirective } from '@syncfusion/ej2-vue-maps';
import { usMap } from './usa.js';

export default {
name: "App",
components: {
"ejs-maps":MapsComponent,
"e-layers":LayersDirective,
"e-layer":LayerDirective,
},
data () {
    return {
        shapeData: usMap,
        markerSettings: [{
            dataSource: [
                { latitude: 40.7424509, longitude: -74.0081468, city: 'New York' }
            ],
        visible:true,
        shape:'Circle',
        fill:'white',
        width:3,
        animationDuration:0,
        border: { width:2, color:'green'},
        tooltipSettings: {
            visible: true,
            valuePath:'city'
        }
        }]
    }
},
provide: {
    maps: [Marker, MapsTooltip]
}
}
</script>
<style>
  .wrapper {
    max-width: 400px;
    margin: 0 auto;
  }
</style>

Add different types of markers

Different marker objects can be added to the Maps component using the marker settings. To update different marker settings in Maps, please follow the given steps:

Step 1:

Initialize the Maps component with marker settings. Here, a marker has been added with specified latitude and longitude of California by using the dataSource property. To customize the shape of the marker using the shape property and change the border color and width of the marker using the border property as mentioned in the following example.

<template>
    <div id="app">
          <div class='wrapper'>
            <ejs-maps >
                <e-layers>
                    <e-layer :shapeData='shapeData' :markerSettings='markerSettings'></e-layer>
                </e-layers>
            </ejs-maps>
        </div>
    </div>
</template>

<script>

import { MapsComponent as EjsMaps, Marker, LayerDirective as ELayer, LayersDirective as ELayers } from '@syncfusion/ej2-vue-maps';
import { world_map } from './world-map.js';

export default {
name: "App",
components: {
"ejs-maps":MapsComponent,
"e-layers":LayersDirective,
"e-layer":LayerDirective
},
data () {
    return {
        shapeData: world_map,
        markerSettings: [{
        dataSource: [
            { latitude: 40.7424509, longitude: -74.0081468, city: 'New York' }],
        visible:true,
        shape: 'Circle',
        fill: 'white',
        width: 3,
        animationDuration:0,
            border: { width: 2, color: '#333' }
        }]
    }
},
provide: {
    maps: [Marker]
}
}
</script>
<style>
  .wrapper {
    max-width: 400px;
    margin: 0 auto;
  }
</style>

Step 2:

Customize the above option for n number of markers as mentioned in the following example.

<template>
    <div id="app">
          <div class='wrapper'>
            <ejs-maps >
                <e-layers>
                    <e-layer :shapeData='shapeData' :markerSettings='markerSettings'></e-layer>
                </e-layers>
            </ejs-maps>
        </div>
    </div>
</template>

<script>

import { MapsComponent, Marker, LayerDirective,LayersDirective} from '@syncfusion/ej2-vue-maps';
import { world_map } from './world-map.js';

export default {
name: "App",
components: {
"ejs-maps":MapsComponent,
"e-layers":LayersDirective,
"e-layer":LayerDirective
},
data () {
    return {
        shapeData: world_map,
        markerSettings: [{
            dataSource: [
                { latitude: 37.6276571, longitude: -122.4276688, city: 'San Bruno' },
            ],
            visible:true,
            shape:'Circle',
            fill:'white',
            width:3,
            animationDuration:0,
            border:{ width: 2, color: '#333'}
        },
        {
            dataSource: [
                { latitude: 33.5302186, longitude: -117.7418381, city: 'Laguna Niguel' },
            ],
            visible:true,
            shape:'Rectangle',
            fill:'yellow',
            width:15,
            height:4,
            animationDuration:0,
            border: { width: 2, color: '#333' }
        },
        {
            dataSource: [
                { latitude: 40.7424509, longitude: -74.0081468, city: 'New York' }
            ],
            visible:true,
            shape:'Diamond',
            fill:'white',
            width:10,
            height:10,
            animationDuration:0,
            border: { width: 2, color: 'blue' }
        }]
    }
},
provide: {
    maps: [Marker]
}
}
</script>
<style>
  .wrapper {
    max-width: 400px;
    margin: 0 auto;
  }
</style>

Markers in Angular Maps component

6 Feb 202624 minutes to read

Markers are visual indicators used to pinpoint specific locations on the Maps. They can display desired symbols to highlight points of interest or important geographic positions. Markers can be enabled by setting thevisible property of the markerSettings to true.

Adding marker

To add the markers, the dataSource property of the markerSettings has a list of objects that contains the data for markers. Using this property, any number of markers can be added to the layers of the Maps. By default, it displays the markers based on the specified latitude and longitude in the given data source. Each data source object contains the following list of properties.

  • latitude - The latitude value that determines the vertical (Y) position of the marker.
  • longitude - The longitude value that determines the horizontal (X) position of the marker.
import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { MapsModule } from '@syncfusion/ej2-angular-maps'
import { MarkerService } from '@syncfusion/ej2-angular-maps'



import { Component, OnInit } from '@angular/core';
import { world_map } from './world-map';
@Component({
imports: [
         MapsModule
    ],

providers: [MarkerService],
standalone: true,
    selector: 'app-container',
    template:
    `<ejs-maps id='rn-container'  >
    <e-layers>
    <e-layer  [shapeData]= 'shapeData' [markerSettings] = 'markerSettings'></e-layer>
    </e-layers>
    </ejs-maps>`
})

export class AppComponent implements OnInit {
    public shapeData?: object;
    public markerSettings?: object;
    ngOnInit(): void {
        this.shapeData = world_map;
        this.markerSettings = [{
            visible: true,
            height: 20,
            width: 20,
            dataSource: [
                { latitude: 49.95121990866204, longitude: 18.468749999999998 },
                { latitude: 59.88893689676585, longitude: -109.3359375 },
                { latitude: -6.64607562172573, longitude: -55.54687499999999 }
            ],
            animationDuration: 0,
        }]
   }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Adding marker template

The Marker can be added as a template in the Maps component. The template property of the markerSettings is used to set the HTML string or id of an element as a template.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { MapsModule } from '@syncfusion/ej2-angular-maps'
import { MarkerService } from '@syncfusion/ej2-angular-maps'



import { Component, OnInit } from '@angular/core';
import { world_map } from './world-map';
@Component({
imports: [
         MapsModule
    ],

providers: [MarkerService],
standalone: true,
    selector: 'app-container',
    template:
    `<ejs-maps id='rn-container'  >
    <e-layers>
    <e-layer  [shapeData]= 'shapeData' [markerSettings] = 'markerSettings'></e-layer>
    </e-layers>
    </ejs-maps>`
})

export class AppComponent implements OnInit {
    public shapeData?: object;
    public markerSettings?: object;
    ngOnInit(): void {
        this.shapeData = world_map;
        this.markerSettings = [
            {
                visible: true,
                template: '<div id="marker4" class="markerTemplate">Europe' +
                        '</div>',
                dataSource: [
                    { latitude: 49.95121990866204, longitude: 18.468749999999998 }
                ],
                animationDuration: 0,
            },
            {
                visible: true,
                template: '<div id="marker5" class="markerTemplate" style="width:50px">North America' +
                        '</div>',
                dataSource: [
                    { latitude: 59.88893689676585, longitude: -109.3359375 }
                ],
                animationDuration: 0
            },
            {
                visible: true,
                template: '<div id="marker6" class="markerTemplate" style="width:50px">South America' +
                        '</div>',
                dataSource: [
                    { latitude: -6.64607562172573, longitude: -55.54687499999999 }
                ],
                animationDuration: 0
            }
        ]
   }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Customization

The following properties are available in markerSettings to customize the Markers of the Maps component.

  • border - To customize the color, width and opacity of the border for the markers in Maps.
  • fill - To apply the color for markers in Maps.
  • dashArray - To define the pattern of dashes and gaps that is applied to the outline of the markers in Maps.
  • height - To customize the height of the markers in Maps.
  • width - To customize the width of the markers in Maps.
  • offset - To customize the position of the markers in Maps.
  • opacity - To customize the transparency of the markers in Maps.
  • animationDelay - To change the time delay in the transition for markers.
  • animationDuration - To change the time duration of animation for markers.
import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { MapsModule } from '@syncfusion/ej2-angular-maps'
import { MarkerService } from '@syncfusion/ej2-angular-maps'



import { Component, OnInit } from '@angular/core';
import { world_map } from './world-map';
@Component({
imports: [
         MapsModule
    ],

providers: [MarkerService],
standalone: true,
    selector: 'app-container',
    template:
    `<ejs-maps id='rn-container'  >
    <e-layers>
    <e-layer  [shapeData]= 'shapeData' [markerSettings] = 'markerSettings'></e-layer>
    </e-layers>
    </ejs-maps>`
})

export class AppComponent implements OnInit {
    public shapeData?: object;
    public markerSettings?: object;
    ngOnInit(): void {
        this.shapeData = world_map;
        this.markerSettings = [{
            visible: true,
            border: {
                color: 'green',
                width: 2
            },
            fill: 'red',
            dashArray: '1',
            height: 20,
            width: 20,
            opacity: 0.9,
            animationDelay: 100,
            animationDuration: 1000,
            shape: 'Balloon',
            dataSource: [
                { latitude: 37.0000, longitude: -120.0000, city: 'California' },
                { latitude: 40.7127, longitude: -74.0059, city: 'New York' },
                { latitude: 42, longitude: -93, city: 'Iowa' }
            ]
        }]
   }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Marker shapes

The Maps component supports the following marker shapes. To set the shape of the marker, the shape property in markerSettings is used.

  • Balloon
  • Circle
  • Cross
  • Diamond
  • Image
  • Rectangle
  • Star
  • Triangle
  • VerticalLine
  • HorizontalLine

Rendering marker shape as image

To render a marker as an image in Maps, set the shape property of markerSettings as Image and specify the path of the image to imageUrl property. There is another way to render a marker as an image using the imageUrlValuePath property of the markerSettings. Bind the field name that contains the path of the image in the data source to the imageUrlValuePath property.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { MapsModule } from '@syncfusion/ej2-angular-maps'
import { MarkerService } from '@syncfusion/ej2-angular-maps'



import { Component, OnInit } from '@angular/core';
import { world_map } from './world-map';
@Component({
imports: [
         MapsModule
    ],

providers: [MarkerService],
standalone: true,
    selector: 'app-container',
    template:
    `<ejs-maps id='rn-container'>
    <e-layers>
    <e-layer  [shapeData]= 'shapeData' [markerSettings] = 'markerSettings'></e-layer>
    </e-layers>
    </ejs-maps>`
})

export class AppComponent implements OnInit {
    public shapeData?: object;
    public markerSettings?: object;
    ngOnInit(): void {
        this.shapeData = world_map;
        this.markerSettings = [{
            visible: true,
            shape: 'Image',
            imageUrl: 'https://ej2.syncfusion.com/angular/demos/assets/maps/images/ballon.png',
            height: 20,
            width: 20,
            dataSource: [
                { latitude: 37.0000, longitude: -120.0000, city: 'California' },
                { latitude: 40.7127, longitude: -74.0059, city: 'New York' },
                { latitude: 42, longitude: -93, city: 'Iowa' }
            ]
        }]
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Multiple marker groups

Multiple groups of markers can be added to the Maps by providing an array of marker configurations to the markerSettings property. Each marker group can have its own customization options defined within the markerSettings.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { MapsModule } from '@syncfusion/ej2-angular-maps'
import { MarkerService } from '@syncfusion/ej2-angular-maps'



import { Component, OnInit } from '@angular/core';
import { world_map } from './world-map';
@Component({
imports: [
         MapsModule
    ],

providers: [MarkerService],
standalone: true,
    selector: 'app-container',
    template:
    `<ejs-maps id='rn-container'  >
    <e-layers>
    <e-layer  [shapeData]= 'shapeData' [markerSettings] = 'markerSettings'></e-layer>
    </e-layers>
    </ejs-maps>`
})

export class AppComponent implements OnInit {
    public shapeData?: object;
    public markerSettings?: object;
    ngOnInit(): void {
        this.shapeData = world_map;
        this.markerSettings = [{
            visible: true,
            shape: 'Diamond',
            height: 15,
            fill: "green",
            width: 15,
            dataSource: [
                {
                    latitude: 37.0000, longitude: -120.0000, name:'California',
                },
                {
                    latitude: 40.7127, longitude: -74.0059, name:"New York"
                },
                {
                    latitude: 42, longitude: -93, name:'Iowa'
                }
            ]
        },
        {
            visible: true,
            dataSource: [{
                latitude: 19.228825, longitude: 72.854118, name: "Mumbai"
            }, {
                latitude: 28.610001, longitude: 77.230003, name: "Delhi"
            }, {
                latitude: 13.067439, longitude: 80.237617, name: "Chennai"
            }],
            shape: 'Circle',
            fill: "blue",
            height: 10,
            width: 10
        }]
   }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Customize marker shapes from data source

Bind different colors and shapes to the marker from data source

Using the shapeValuePath and colorValuePath properties, the color and shape of the marker can be applied from the given data source. Bind the data source to the dataSource property of the markerSettings and set the field names that contains the shape and color values in the data source to the shapeValuePath and colorValuePath properties.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { MapsModule } from '@syncfusion/ej2-angular-maps'
import { MarkerService } from '@syncfusion/ej2-angular-maps'



import { Component, OnInit } from '@angular/core';
import { world_map } from './world-map';
@Component({
imports: [
         MapsModule
    ],

providers: [MarkerService],
standalone: true,
    selector: 'app-container',
    template:
    `<ejs-maps id='rn-container' >
    <e-layers>
    <e-layer  [shapeData]= 'shapeData' [markerSettings] = 'markerSettings'></e-layer>
    </e-layers>
    </ejs-maps>`
})

export class AppComponent implements OnInit {
    public shapeData?: object;
    public markerSettings?: object;
    ngOnInit(): void {
        this.shapeData = world_map;
        this.markerSettings = [{
            visible: true,
            shapeValuePath:'shape',
            colorValuePath:'color',
            dataSource: [
                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe', color:'red', shape:'Triangle' },
                { latitude: 59.88893689676585, longitude: -109.3359375, name:'North America',
                color:'blue', shape:'Pentagon' },
                { latitude: -6.64607562172573, longitude: -55.54687499999999, name:'South America',
                color:'green', shape:'InvertedTriangle' }
            ]
        }];
   }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Setting value path from the data source

The latitude and longitude values are used to determine the location of each marker in the Maps. The latitudeValuePath and longitudeValuePath properties are used to specify the value path that presents in the data source of the marker. In the following example, the field name from the data source is set to the latitudeValuePath and longitudeValuePath properties.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { MapsModule } from '@syncfusion/ej2-angular-maps'
import { MarkerService } from '@syncfusion/ej2-angular-maps'



import { Component, OnInit } from '@angular/core';
import { world_map } from './world-map';
@Component({
imports: [
         MapsModule
    ],

providers: [MarkerService],
standalone: true,
    selector: 'app-container',
    template:
    `<ejs-maps id='rn-container'  >
    <e-layers>
    <e-layer  [shapeData]= 'shapeData' [markerSettings] = 'markerSettings'></e-layer>
    </e-layers>
    </ejs-maps>`
})

export class AppComponent implements OnInit {
    public shapeData?: object;
    public markerSettings?: object;
    ngOnInit(): void {
        this.shapeData = world_map;
        this.markerSettings = [{
            visible: true,
            latitudeValuePath: 'latitude',
            longitudeValuePath: 'longitude',
            dataSource: [
                { latitude: 49.95121990866204, longitude: 18.468749999999998 },
                { latitude: 59.88893689676585, longitude: -109.3359375},
                { latitude: -6.64607562172573, longitude: -55.54687499999999 }
            ]
        }]
   }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Setting different sizes for markers individually

The size of the markers in a marker group can be customized using the widthValuePath and heightValuePath properties, which allow the user to change the width and height of the markers based on values from the given data source. Bind the data source to the dataSource property of the markerSettings, and specify the field names containing the width and height values in the data source for the widthValuePath and heightValuePath properties.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { MapsModule } from '@syncfusion/ej2-angular-maps';
import { MarkerService } from '@syncfusion/ej2-angular-maps';
import { Component, OnInit } from '@angular/core';
import { world_map } from './world-map';
@Component({
imports: [
         MapsModule
    ],

providers: [MarkerService],
standalone: true,
    selector: 'app-container',
    template:
    `<ejs-maps id='rn-container'  >
    <e-layers>
    <e-layer  [shapeData]= 'shapeData' [markerSettings] = 'markerSettings'></e-layer>
    </e-layers>
    </ejs-maps>`
})

export class AppComponent implements OnInit {
    public shapeData?: object;
    public markerSettings?: object;
    ngOnInit(): void {
        this.shapeData = world_map;
        this.markerSettings = [{
            visible: true,
            shape: 'Circle',
            widthValuePath: 'width',
            heightValuePath: 'height',
            dataSource: [
                {
                    latitude: 49.95121990866204,
                    longitude: 18.468749999999998,
                    width: 30,
                    height: 30,
                },
                {
                    latitude: 59.88893689676585,
                    longitude: -109.3359375,
                    width: 20,
                    height: 20,
                },
                {
                    latitude: -6.64607562172573,
                    longitude: -55.54687499999999,
                    width: 10,
                    height: 10,
                }
            ]
        }]
   }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Repositioning the marker using drag and drop

The markers on the map can be dragged and dropped to change their position. To enable marker drag and drop, set the enableDrag property to true in the markerSettings property.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { MapsModule } from '@syncfusion/ej2-angular-maps'
import { MarkerService, MapsTooltipService } from '@syncfusion/ej2-angular-maps'

import { Component, OnInit } from '@angular/core';
import { world_map } from './world-map';
@Component({
imports: [
         MapsModule
    ],

providers: [MarkerService, MapsTooltipService],
standalone: true,
    selector: 'app-container',
    template:
    `<ejs-maps id='rn-container'>
    <e-layers>
    <e-layer [shapeSettings] = 'shapeSettings'  [shapeData]= 'shapeData' [markerSettings] = 'markerSettings'></e-layer>
    </e-layers>
    </ejs-maps>`
})

export class AppComponent implements OnInit {
    public shapeData?: object;
    public markerSettings?: object;
    public shapeSettings?: object;
    ngOnInit(): void {
        this.shapeData = world_map;
        this.shapeSettings = {
            fill: '#C3E6ED'
        };
        this.markerSettings = [{
            enableDrag: true,
            dataSource: [
                 { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'MarkerOne' },
                 { latitude: 59.88893689676585, longitude: -109.3359375, name:'MarkerTwo'},
                 { latitude: -6.64607562172573, longitude: -55.54687499999999 , name:'MarkerThree'},
                 { latitude: 23.644385824912135, longitude: 77.83189239539234  , name:'MarkerFour'},
                 { latitude: 63.66569332894224, longitude: 98.2225173953924 , name:'MarkerFive'}
            ],
            visible: true,
            animationDuration: 0,
            shape: 'Balloon',
            width: 20,
            height: 20,
            border: { width: 2, color: '#285255' },
            tooltipSettings: {
                visible: true,
                valuePath: 'name',
            }
        }]
   }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

The data of the drag and dropped marker in the marker data source can be customized using the markerDragStart and markerDragEnd events. When you change the appropriate marker data, the tooltip and legend item text of that marker are automatically updated. The following properties are available in the event argument of the marker drag events.

Argument Name Description
dataIndex It represents the index of the data of the dragged marker in the marker data source.
latitude It represents the latitude coordinate point of the dragged marker.
longitude It represents the longitude coordinate point for the dragged marker.
markerIndex It represents the index of the marker setting.
layerIndex It represents the index of the layer in which the marker belongs.
name It represents the name of the event.
x It represents the horizontal location of the mouse pointer on the map when the drag action is performed.
y It represents the vertical location of the mouse pointer on the map when the drag action is performed.

The following example shows how to use marker drag events to customize the data of the drag and dropped marker in the marker data source.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { MapsModule } from '@syncfusion/ej2-angular-maps'
import { LegendService, MarkerService, MapsTooltipService } from '@syncfusion/ej2-angular-maps'

import { Component, OnInit, ViewChild } from '@angular/core';
import { Maps, IMarkerDragEventArgs } from '@syncfusion/ej2-angular-maps';
import { world_map } from './world-map';
@Component({
imports: [
         MapsModule
    ],

providers: [LegendService, MarkerService, MapsTooltipService],
standalone: true,
    selector: 'app-container',
    template: `
        <ejs-maps id="rn-container" #maps (markerDragStart)="markerDragStart($event)" (markerDragEnd)="markerDragEnd($event)" [legendSettings]="legendSettings">
        <e-layers>
            <e-layer [shapeSettings]="shapeSettings" [shapeData]="shapeData" [markerSettings]="markerSettings"></e-layer>
        </e-layers>
    </ejs-maps>`
})

export class AppComponent implements OnInit {
    @ViewChild('maps')
    public mapsInstance?: Maps;
    public shapeData?: object;
    public markerSettings?: object;
    public shapeSettings?: object;
    public zoomSettings?: object;
    public markerDragStart = (args: IMarkerDragEventArgs | any) => {
      // When the marker begins to move on the map, the event is triggered.
    };
    public markerDragEnd = (args: IMarkerDragEventArgs | any) => {
      // When the marker on the map stops dragging, the event is triggered.
      (this.mapsInstance as any).layers[args.layerIndex].markerSettings[args.markerIndex].dataSource[args.dataIndex].name = 'Dragged Marker ' + (args.dataIndex + 1);
      (this.mapsInstance as Maps).refresh();
    };
    public legendSettings?: object;

    ngOnInit(): void {
        this.shapeData = world_map;
        this.legendSettings = {
            visible: true,
            type: 'Markers',
            shape: 'Circle',
            shapeWidth: 10,
            shapeHeight: 10,
            fill: '#FF471A',
            shapeBorder: { width: 2, color: '#285255' },
        };
        this.shapeSettings = {
          fill: '#C3E6ED',
        };
        this.zoomSettings = {
          enable: false,
        };
        this.markerSettings = [
        {
            enableDrag: true,
            legendText: 'name',
            dataSource: [
                {
                  latitude: 49.95121990866204,
                  longitude: 18.468749999999998,
                  name: 'MarkerOne',
                },
                {
                  latitude: 59.88893689676585,
                  longitude: -109.3359375,
                  name: 'MarkerTwo',
                },
                {
                  latitude: -6.64607562172573,
                  longitude: -55.54687499999999,
                  name: 'MarkerThree',
                },
                {
                  latitude: 23.644385824912135,
                  longitude: 77.83189239539234,
                  name: 'MarkerFour',
                },
                {
                  latitude: 63.66569332894224,
                  longitude: 98.2225173953924,
                  name: 'MarkerFive',
                },
            ],
            visible: true,
            animationDuration: 0,
            shape: 'Balloon',
            width: 20,
            height: 20,
            border: { width: 2, color: '#285255' },
            tooltipSettings: {
              visible: true,
              valuePath: 'name',
            },
        },
    ];
   }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Marker zooming

The Maps can be initially scaled to fit all markers within the visible area. This can be achieved by setting the shouldZoomInitially property in zoomSettings to true.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { MapsModule } from '@syncfusion/ej2-angular-maps'
import { MarkerService, ZoomService } from '@syncfusion/ej2-angular-maps'



import { Component, OnInit } from '@angular/core';
import { world_map } from './world-map';
@Component({
imports: [
         MapsModule
    ],

providers: [MarkerService, ZoomService],
standalone: true,
    selector: 'app-container',
    template:
    `<ejs-maps id='rn-container'  [zoomSettings] ='zoomSettings'>
    <e-layers>
    <e-layer  [shapeData]= 'shapeData' [markerSettings] = 'markerSettings'></e-layer>
    </e-layers>
    </ejs-maps>`
})

export class AppComponent implements OnInit {
    public shapeData?: object;
    public markerSettings?: object;
    public zoomSettings?: object
    ngOnInit(): void {
        this.shapeData = world_map;
        this.markerSettings = [
        {
            visible: true,
            dataSource: [
                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                { latitude: 59.88893689676585, longitude: -109.3359375, name:'North America' },
                { latitude: -6.64607562172573, longitude: -55.54687499999999, name:'South America'}
            ],
        },
        ];
        this.zoomSettings = {
            enable: true,
            shouldZoomInitially: true,
            toolbarSettings: {
                horizontalAlignment: 'Near'
            }
        }
   }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Marker clustering

The Maps component provides support to cluster markers when they overlap each other. The number displayed on a cluster indicates how many overlapping markers it contains. When zooming in on a cluster location, the cluster count decreases as individual markers become visible. When zooming out, overlapping markers are grouped again, increasing the cluster count.

To enable clustering for markers, set the allowClustering property of markerClusterSettings in the layers to true. Customization of clustering can be done using the markerClusterSettings property.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { MapsModule } from '@syncfusion/ej2-angular-maps'
import { MarkerService, MapsTooltipService, ZoomService } from '@syncfusion/ej2-angular-maps'



import { Component, ViewEncapsulation, ViewChild, OnInit  } from '@angular/core';
import { world_map } from './world-map';
import { cluster } from './marker-location';;
@Component({
imports: [
         MapsModule
    ],

providers: [MarkerService, MapsTooltipService, ZoomService],
standalone: true,
    selector: 'app-container',
    template:
    `<ejs-maps id='rn-container' [zoomSettings] = 'zoomSettings' [layers] = 'layers'>
    </ejs-maps>`
})

export class AppComponent implements OnInit {
    public zoomSettings?: object;
    public layers?: object;
    ngOnInit(): void {
        this.zoomSettings = {
            enable: true
        };
        this.layers = [{
            shapeData: world_map,
            shapeSettings: { fill: '#C1DFF5' },
            markerClusterSettings: {
                allowClustering: true,
                shape: 'Circle',
                height: 40,
                width: 40,
                labelStyle: { color: 'white' },
            },
            markerSettings: [{
                dataSource: cluster,
                visible: true,
                animationDuration: 0,
                shape: 'Balloon',
                height: 20,
                width: 20,
                tooltipSettings: {
                    visible: true,
                    valuePath: 'area',
                }
            }]
        }];
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Customization of marker cluster

The following properties are available to customize the marker clustering in the Maps component.

  • border - To customize the color, width and opacity of the border of cluster in Maps.
  • connectorLineSettings - To customize the connector line in cluster separating the markers.
  • dashArray - To customize the dash array for the marker cluster in Maps.
  • fill - Applies the color of the cluster in Maps.
  • height - To customize the height of the marker cluster in Maps.
  • imageUrl - To customize the URL path for the marker cluster when the cluster shape is set as image in Maps.
  • labelStyle - To customize the text in marker cluster.
  • offset - To customize the offset position for the marker cluster in Maps.
  • opacity - To customize the opacity of the marker cluster.
  • shape - To customize the shape for the cluster of markers.
  • width - To customize the width of the marker cluster in Maps.
import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { MapsModule } from '@syncfusion/ej2-angular-maps'
import { MarkerService, MapsTooltipService, ZoomService } from '@syncfusion/ej2-angular-maps'



import { Component, OnInit  } from '@angular/core';
import { Point } from '@syncfusion/ej2-angular-maps';
import { world_map } from './world-map';
import { cluster } from './marker-location';;
@Component({
imports: [
         MapsModule
    ],

providers: [MarkerService, MapsTooltipService, ZoomService],
standalone: true,
    selector: 'app-container',
    template:
    `<ejs-maps id='rn-container' [zoomSettings] = 'zoomSettings' [layers] = 'layers'>
    </ejs-maps>`
})

export class AppComponent implements OnInit {
    public zoomSettings?: object;
    public layers?: object;
    ngOnInit(): void {
        this.zoomSettings = {
            enable: true
        };
        this.layers = [{
            shapeData: world_map,
            shapeSettings: { fill: '#C1DFF5' },
            markerClusterSettings: {
                allowClustering: true,
                allowClusterExpand: true,
                shape: 'Circle',
                height: 40,
                width: 40,
                labelStyle : { color: 'white'},
                offset: new Point(10, 20),
                opacity: 0.9,
                fill: 'green',
                connectorLineSettings: {
                    color: 'orange',
                    opacity: 0.8,
                    width: 2
                }
            },
            markerSettings: [{
                dataSource: cluster,
                visible: true,
                animationDuration: 0,
                shape: 'Balloon',
                height: 20,
                width: 20,
                tooltipSettings: {
                    visible: true,
                    valuePath: 'area',
                }
            }]
        }];
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Expanding the marker cluster

The cluster is formed by grouping an identical and non-identical marker from the surrounding area. By clicking on the cluster and setting the allowClusterExpand property in markerClusterSettings as true to expand the identical markers. If zooming is performed in any of the locations of the cluster, the number on the cluster will decrease and the overlapping marker will be split into an individual marker on the map. When performing zoom out, it will increase the marker count and then cluster it again.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { MapsModule } from '@syncfusion/ej2-angular-maps'
import { MarkerService, ZoomService } from '@syncfusion/ej2-angular-maps'



import { Component, OnInit } from '@angular/core';
import { world_map } from './world-map';
@Component({
imports: [
         MapsModule
    ],

providers: [MarkerService, ZoomService],
standalone: true,
    selector: 'app-container',
    template:
    `<ejs-maps id='rn-container'  [zoomSettings] ='zoomSettings'  >
    <e-layers>
    <e-layer  [shapeData]= 'shapeData' [markerSettings] = 'markerSettings' [markerClusterSettings] = 'markerClusterSettings'></e-layer>
    </e-layers>
    </ejs-maps>`
})

export class AppComponent implements OnInit {
    public shapeData?: object;
    public markerSettings?: object;
    public zoomSettings?: object;
    public markerClusterSettings?: object;
    ngOnInit(): void {
        this.shapeData = world_map;
        this.markerSettings = [{
            visible: true,
            dataSource: [
                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                { latitude: 49.95121990866204, longitude: 18.468749999999998, name:'Europe' },
                { latitude: 59.88893689676585, longitude: -109.3359375, name:'North America' },
                { latitude: -6.64607562172573, longitude: -55.54687499999999, name:'South America'}
            ]
        }];
        this.zoomSettings = {
            enable: true,
            mouseWheelZoom : true,
        },
        this.markerClusterSettings = {
            allowClustering: true,
            allowClusterExpand: true,
            shape: 'Circle',
            height: 40,
            width: 40,
            labelStyle : { color: 'white'},
        }
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Clustering markers within each marker group

Marker clustering can be enabled for each marker group in the map by using the clusterSettings property within the markerSettings property in the layers. This allows for individual customization of clusters for each marker group which group markers that are located near each other to reduce clutter and improve readability. When the allowClustering property is set to true, the markers within each group are clustered and visually represented as separate clusters. As users zoom in, the clusters expand to reveal individual markers, enabling more detailed exploration. Clusters can also be expanded manually by setting the allowClusterExpand property to true. The appearance of the clusters and their expansion behavior can be customized using the clusterSettings property, similar to the markerClusterSettings property, as explained in the sections above.

When the clusterSettings property is enabled for an individual marker group, the markerClusterSettings property within the layers becomes ineffective.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { MapsModule } from '@syncfusion/ej2-angular-maps';
import { MarkerService, MapsTooltipService, ZoomService } from '@syncfusion/ej2-angular-maps';
import { Component, OnInit  } from '@angular/core';
import { world_map } from './world-map';
@Component({
imports: [
         MapsModule
    ],

providers: [MarkerService, MapsTooltipService, ZoomService],
standalone: true,
    selector: 'app-container',
    template:
    `<ejs-maps id='container' style="display:block;" [layers]='layers' [zoomSettings]="zoomSettings" [titleSettings]="titleSettings">
     </ejs-maps>`
})

export class AppComponent implements OnInit {
    public zoomSettings?: object;
    public layers?: object;
    public titleSettings?: object;
    ngOnInit(): void {
        this.zoomSettings ={
            enable: true,
            toolbarSettings: {
                buttonSettings: {
                    toolbarItems: ['Zoom', 'ZoomIn', 'ZoomOut', 'Pan', 'Reset']
                }
            }
        };
        this.titleSettings = {
            text: 'Attractive places around the world',
            textStyle: {
                size: '16px'
            }
        };
        this.layers = [{
            shapeData: world_map,
            markerSettings: [
                {
                    clusterSettings: {
                        allowClustering: true,
                        allowDeepClustering: false,
                        allowClusterExpand: true,
                        labelStyle: {
                            color: 'white',
                            size: '10px'
                        },
                        shape: 'Image',
                        height: 40, width: 40,
                        imageUrl: 'https://ej2.syncfusion.com/angular/demos/assets/maps/images/cluster-france.svg'
                    },
                    visible: true,
                    dataSource: [
                        { latitude: 48.8584, longitude: 2.2945, name: 'Eiffel Tower', state: 'Paris', country: 'France' },
                        { latitude: 48.8606, longitude: 2.3376, name: 'Louvre Museum', state: 'Paris', country: 'France' },
                        { latitude: 48.8529, longitude: 2.3500, name: 'Notre-Dame Cathedral', state: 'Paris', country: 'France' },
                        { latitude: 48.6360, longitude: 1.5115, name: 'Mont Saint-Michel', state: 'Normandy', country: 'France' }
                    ],
                    shape: 'Circle',
                    height: 15,
                    width: 15,
                    fill: '#b38600',
                    border: {
                        color: '#e6f2ff',
                        width: 2
                    },
                    tooltipSettings: {
                        visible: true,
                        valuePath: 'name',
                        format: '<b>Name:</b> ${name} <br/> <b>State:</b> ${state} <br/> <b>Country:</b> ${country}'
                    },
                    animationDuration: 0
                },
                {
                    clusterSettings: {
                        allowClustering: true,
                        allowDeepClustering: false,
                        allowClusterExpand: true,
                        shape: 'Image',
                        height: 40, width: 40,
                        labelStyle: {
                            color: 'white',
                            size: '10px'
                        },
                        imageUrl: 'https://ej2.syncfusion.com/angular/demos/assets/maps/images/cluster-usa.svg'
                    },
                    visible: true,
                    dataSource: [
                        { latitude: 35.019028, longitude: -85.339439, name: 'Ruby Falls', state: 'Tennessee', country: 'United States of America' },
                        { latitude: 35.654613, longitude: -105.996979, name: 'Meow Wolf Santa Fe', state: 'New Mexico', country: 'United States of America' },
                        { latitude: 36.107216, longitude: -115.175804, name: 'City Center of Las Vegas', state: 'Nevada', country: 'United States of America' },
                        { latitude: 36.879047, longitude: -111.510498, name: 'Horseshoe Bend', state: 'Arizona', country: 'United States of America' },
                        { latitude: 36.011955, longitude: -113.810951, name: 'Grand Canyon West Skywalk', state: 'Arizona', country: 'United States of America' }
                    ],
                    shape: 'Circle',
                    height: 15,
                    width: 15,
                    fill: '#bf4040',
                    border: {
                        color: '#e6f2ff',
                        width: 2
                    },
                    tooltipSettings: {
                        visible: true,
                        valuePath: 'name',
                        format: '<b>Name:</b> ${name} <br/> <b>State:</b> ${state} <br/> <b>Country:</b> ${country}'
                    },
                    animationDuration: 0
                },
                {
                    clusterSettings: {
                        allowClustering: true,
                        allowDeepClustering: false,
                        allowClusterExpand: true,
                        shape: 'Image',
                        height: 40, width: 40,
                        labelStyle: {
                            color: 'white',
                            size: '10px'
                        },
                        imageUrl: 'https://ej2.syncfusion.com/angular/demos/assets/maps/images/cluster-india.svg'
                    },
                    visible: true,
                    dataSource: [
                        { latitude: 26.985901, longitude: 75.850700, name: 'Amber Fort, Amer', state: 'Rajastan', country: 'India' },
                        { latitude: 22.957390, longitude: 77.625275, name: 'Bhimbetka, Raisen District', state: 'Madhya Pradesh', country: 'India' },
                        { latitude: 26.809330, longitude: 75.540527, name: 'Bagru Fort, Bagru', state: 'Rajasthan', country: 'India' },
                        { latitude: 25.489504, longitude: 80.330116, name: 'Kalinjar Fort, Banda', state: 'Uttar Pradesh', country: 'India' },
                        { latitude: 27.988890, longitude: 76.388336, name: 'Neemrana', state: 'Rajasthan', country: 'India' }
                    ],
                    shape: 'Circle',
                    fill: '#00b3b3',
                    border: {
                        color: '#e6f2ff',
                        width: 2
                    },
                    height: 15,
                    width: 15,
                    tooltipSettings: {
                        visible: true,
                        valuePath: 'name',
                        format: '<b>Name:</b> ${name} <br/> <b>State:</b> ${state} <br/> <b>Country:</b> ${country}'
                    },
                    animationDuration: 0
                }
            ]
        }];
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Tooltip for markers

Tooltips are used to display additional information about a marker on mouse hover or touch end events. This can be enabled for markers by setting the visible property of tooltipSettings to true. The valuePath property in the tooltipSettings specifies the field name from the data source whose value will be displayed as the tooltip text.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { MapsModule } from '@syncfusion/ej2-angular-maps'
import { MarkerService, MapsTooltipService } from '@syncfusion/ej2-angular-maps'



import { Component, OnInit } from '@angular/core';
import { usa_map } from './usa';
@Component({
imports: [
         MapsModule
    ],

providers: [MarkerService, MapsTooltipService],
standalone: true,
    selector: 'app-container',
    template:
    `<ejs-maps id='rn-container'>
    <e-layers>
    <e-layer  [shapeData]= 'shapeData' [markerSettings] = 'markerSettings'></e-layer>
    </e-layers>
    </ejs-maps>`
})

export class AppComponent implements OnInit {
    public shapeData?: object;
    public markerSettings?: object;
    ngOnInit(): void {
        this.shapeData = usa_map;
        this.markerSettings = [{
            dataSource: [
                { latitude: 40.7424509, longitude: -74.0081468, city: 'New York' }
            ],
            visible:true,
            shape:'Circle',
            fill:'white',
            width:3,
            animationDuration:0,
            border: { width:2, color:'green'},
            tooltipSettings: {
                visible: true,
                valuePath:'city'
            }
        }]
   }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Add different types of markers

Different marker objects can be added to the Maps component using the marker settings. To update different marker settings in Maps, please follow the given steps:

Step 1:

Initialize the Maps component with marker settings. Here, a marker has been added with specified latitude and longitude of California by using the dataSource property. To customize the shape of the marker using the shape property and change the border color and width of the marker using the border property as mentioned in the following example.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { MapsModule } from '@syncfusion/ej2-angular-maps'
import { MarkerService } from '@syncfusion/ej2-angular-maps'



import { Component, ViewEncapsulation } from '@angular/core';
import { usa_map } from './usa';

@Component({
imports: [
         MapsModule
    ],

providers: [MarkerService],
standalone: true,
    selector: 'app-container',
    // specifies the template string for the maps component
    template:`<ejs-maps id='container'>
    <e-layers>
    <e-layer [shapeData]='usmap' [markerSettings]='markerSettings'></e-layer>
    </e-layers>
    </ejs-maps>`,
    encapsulation: ViewEncapsulation.None
  })
  export class AppComponent {
       public usmap=usa_map;
       public markerSettings = [
        {
            dataSource: [
                { latitude: 37.0000, longitude: -120.0000, city: 'California' }
            ],
            visible:true,
            shape:'Circle',
            fill:'white',
            width:3,
            animationDuration:0,
            border:{width:2,color:'#333'}
       }
    ]
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Step 2:

Customize the above option for n number of markers as mentioned in the following example.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { MapsModule } from '@syncfusion/ej2-angular-maps'
import { MarkerService } from '@syncfusion/ej2-angular-maps'



import { Component, ViewEncapsulation } from '@angular/core';
import { usa_map } from './usa';

@Component({
imports: [
         MapsModule
    ],

providers: [MarkerService],
standalone: true,
    selector: 'app-container',
    // specifies the template string for the maps component.
    template:`<ejs-maps id='container'>
    <e-layers>
    <e-layer [shapeData]='usmap' [markerSettings]='markerSettings'></e-layer>
    </e-layers>
    </ejs-maps>`,
    encapsulation: ViewEncapsulation.None
  })
  export class AppComponent {
       public usmap=usa_map;
       // Initializing Map with Marker sttings.
       public markerSettings = [
        {
            dataSource: [
                { latitude: 37.0000, longitude: -120.0000, city: 'California' }
            ],
            visible:true,
            shape:'Circle',
            fill:'white',
            width:3,
            animationDuration:0,
            border:{width:2,color:'#333'}
        },
        {
            dataSource: [
                { latitude: 40.7127, longitude: -74.0059, city: 'New York' }
            ],
            visible:true,
            shape:'Rectangle',
            fill:'yellow',
            width:15,
            height:4,
            animationDuration:0,
            border:{width:2,color:'#333'}
        },
        {
            dataSource: [
                { latitude: 42, longitude: -93, city: 'Iowa' }
            ],
            visible:true,
            shape:'Diamond',
            fill:'white',
            width:10,
            height:10,
            animationDuration:0,
            border:{width:2,color:'blue'}
        },
        {
            dataSource: [
                { latitude:36.499589049395055, longitude:-103.042108197135548, city:'New Mexico'}
            ],
            visible:true,
            shape:'Balloon',
            fill:'red',
            width:10,
            height:15,
            animationDuration:0,
            border:{width:2,color:'#333'}
        },
        {
            dataSource: [
                { latitude:36.360624205142919, longitude:-94.595916790727287, city:'Oklahoma'}
            ],
            visible:true,
            shape:'Triangle',
            fill:'blue',
            width:10,
            animationDuration:0,
            border:{width:2,color:'#333'}
        }
    ]
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));